--- moodss 21.5 and moomps 5.8 ---------------------------------- 2006-11-19 ---
- in moodss GUI:
  - added Edit/Page Thresholds menu and Thresholds entry in page background
    popup menu in order to edit only the thresholds for the current page
- used patched email (tcllib smtp code) library that ensures that email data
  section is properly terminated
- in moodss makefile, moved all modules help data to documentation directory
- in moomps rpm specification, properly support 64 bit architecture by passing
  library directories to make
- in moomps, also included code from tcllib 1.9 release
- made moomps rpm package architecture dependant since for example Tcl packages
  are under /usr/lib on i386 and /usr/lib64 on x86_64 architecture
--- moodss 21.4 ------------------------------------------------- 2006-10-25 ---
- in moodss GUI:
  - in File/Modules/Manage/Loaded dialog box, modules were sorted
    alphabetically, but their displayed parameters would be incorrect
    (PLEASE UPGRADE from moodss 21.3)
  - significantly improved thresholds dialog box opening and closing times
  - uses newest BWidget 1.8.0 release
- includes md5, uri, base64, smtp and mime source from new tcllib 1.9 release
--- moodss 21.3 and moomps 5.7 ---------------------------------- 2006-10-10 ---
- in moodss GUI:
  - in thresholds dialog box, added "no trace" check button, useful with
    dashboards displaying colored cells for status, for which a threshold
    message in the trace window becomes disturbing
  - made sure initialization messages, for modules, viewers, ... are always
    visible in the message area (useful when loading big dashboards)
  - significantly improved performance on big dashboards with many colored
    thresholds
  - in preferences predictor section, R statistical engine version 2.3 caused
    version checking to fail
  - selection sunken visual effect did not occur every time in adjacent
    colored table cells
  - in pages, no longer allow double-clicking to edit tabs
  - in read-only mode, disallowed editing page tabs
- in snmptrap module, added compatibility with Tnm version 3, added source peer
  address (or host) column and -n (no name lookup) option, removed useless
  --address and --port options
- made snmptrap module work on OS X
- in moomps installation stage, use global variables in makefile to generate rc
  initialization control script
- in moodss installation stage, use variable in makefile for moomps rc file
  location
- moodss and moomps now work on OS X, thanks to Mark Duling's excellent work,
  who made DarwinPorts packages and a great HOWTO
  (http://homepage.mac.com/duling/halfdozen/Moodss-Howto.html)
- successfully tested Japanese input using SCIM on Fedora Core 5 platform
--- moodss 21.2 and moomps 5.6 ---------------------------------- 2006-04-11 ---
- in moodss GUI:
  - on UNIX platforms, print message on fatal X Window error
  - only handle -display option instead of the X Window -colormap, -geometry,
    -name, -sync, -use and -visual options and their abbreviations
  - in formulas, added delta32() function to handle ever increasing 32 bit
    counters in a manner compatible with 32 and 64 bit platforms (make sure
    to carefully read related formulas help or HTML documentation for related
    adjustments on the existing delta() function)
  - when browsing the database, worked around an error caused by a Tcl 8.4.9
    problem
- when moodss or moomps exits, either from user action or abruptly, the loaded
  modules terminate procedures are invoked if they exist, so that, for example,
  some cleanup can occur (note to module developers: terminate procedures
  should not potentially hang, as it would also hang the application)
- abort when attempting to record 64 bit module data in a 32 bit database
- when recording data cells in database, a database error would generate extra
  error messages related to internal code and therefore uninteresting for the
  user
- in SNMP snmp and smithy modules, properly handle 32 and 64 bit counters, even
  on 64 bit platforms, while ignoring presumingly invalid (too large)
  differences between 2 successive poll samples
- in apache and apachex modules, fixed internal library problem, which
  prevented loading
- in the following modules, made calculations on 32 bit data counters (that can
  wrap around) compatible with 64 bit platforms:
    apache, diskstats, interrupts, netdev, myhealth, myshow, ps, psbyname,
    psbyuser
- in the following modules, detect, report and skip duplicated rows (with
  identical hashed number, should be very rare):
    snmp, smithy, psbyname, psbyuser, kernmods, mounts, netdev, ping
- in development HTML documentation, explained how to use the hashes
  repeatable boolean argument in persistent modules
- fixed erroneous date problem in threshold email messages
- in MySQL and SNMP related modules, removed internal Tcl library path
  compensation for incorrect installation
- implemented support for 32 bit database rows on 64 bit platforms (very rare)
- in moomps rpm specification file, in post installation stage, fix moodss
  modules path (needed for x86_64 architecture)
- successfully developed and tested on Red Hat Fedora Core 5 (with gcc 4.1)
--- moodss 21.1 and moomps 5.5 ---------------------------------- 2006-03-04 ---
- in moodss GUI:
  - in predictor tool
    - allowed estimate of the data main period using fast Fourier transform
     (FFT)
    - do not loose previously fitted data when user aborts fitting process
    - display fitting time once best statistical model is fitted
    - handle duplicated data samples by averaging values
  - trace window now automatically opens by default on any module error,
    warning or informational message
  - in preferences application trace page, added check button to control the
    automatic display of the trace window
  - when browsing database, erasing 1 of 2 disjoined instances could result in
    blue cursors to become invisible
  - hiding or showing the toolbar resulted in an error (bug introduced in 21.0
    release)
- added myshow module for monitoring either the status or the system variables
  of a MySQL SQL database server
- rendered mystatus and myvars MySQL modules obsolete (use myshow --status and
  --variables instead)
- in moomps rpm specification file, use Fedora technique for adding user with
  pre-defined UID
- in standalone Linux binary:
  - included the R statistical engine.
  - added a 64 bit AMD/Intel version
--- moodss 21.0 and moomps 5.4 ---------------------------------- 2006-01-23 ---
- in moodss GUI:
  - implemented new predictor tool for future behavior prediction based on past
    data cell history from moodss SQL database (not available for Windows)
  - implemented interface to R statistical calculation engine:
    - glue procedures for ARIMA functions
    - native code and glue procedures for neural net functions
    - multiple concurrent R processes and priority management
  - added Tool/Predictor menu
  - in preferences, added Tool/Predictor page
  - included common time series samples for user training on predictor
  - added HTML document also used in moodss application help interface, complete
    with examples, screenshots, manual and statistics methods documentation
  - when loading another instance of a module from the database, the
    View/Objects menu was not properly updated
  - View/Trace menu is now also usable in database mode
  - allowed loading dashboard from standard input (allows pre-processing) in
    command line using the -f(--file) option with "-" as argument value
  - usage was not printed in case of missing or bad option argument in command
    line
  - in case of database error, View/Trace menu did not show that trace window
    was opened
  - increased main window size so that a new predictor tool window fits
- in database layer, for ODBC connections, let the ODBC layer handle locks via
  transactions (except for MySQL), which solves SQL Server problem on new module
  instances
- updated myvars, myhealth and mystatus modules for MySQL 5.0 support
- in moodss rpm specification, required R package (available in Fedora Extras)
- includes md5, uri, base64, smtp and mime source from new tcllib 1.8 release
- in standalone binary, upgraded Tcl/Tk to 8.4.12 from 8.4.11
- in standalone binary and Windows distribution, included SQLite 3.2.8
--- moodss 20.4 and moomps 5.3 ---------------------------------- 2005-08-23 ---
- in moodss GUI:
  - graph viewers now feature a new, more precise, albeit needing more
    computing resources, implementation, which results in the stacked graph
    viewer behaving properly when resized and when displaying voids or new data
    cells on top of existing ones
  - when dynamically loading a module that would result in the global poll time
    being changed, displayed viewers, such as graphical viewers did not have
    their scales updated properly
  - in graph viewers, lower Y axis limit (red arrow) was not always updated
    properly in database browsing mode
  - preferences were not internally initialized when hiding tool bar without
    having saved the preferences first (as when the application is first used),
    which resulted in an application error
  - in message area, when any first instance of a module updated, the module
    name wrongly included a 0 instance number trailer in the update message
  - asynchronous Perl module now also display a message when updating
  - the Tcl shell is now used as application core (instead of wish, the
    graphical library being dynamically loaded after startup) and its path is no
    longer hardcoded but found within the user environment instead
  - in preferences dialog box, if moomps daemon resource file could not be
    created, such error was correctly reported but not properly internally
    handled
  - in free text viewers:
    - added popup menu with Control-+ and Control-- key bindings to increase
      or decrease text size
    - background color can also be changed via the popup menu
    - use technique identical to formulas for saving text, which guarantees
      precise placement of embedded cells (note: backward compatibility is
      preserved but existing dashboards needs be re-saved)
  - set lower limit of graphs displayed X axis range to 10 seconds in order to
    limit X scale errors
- added support of SQL Server via ODBC
- in random module, use 32 and 64 bit limits as row numbers in order to be able
  to precisely test 64 bit database compatibility
- in standalone binary, upgraded Tcl/Tk to 8.4.11 from 8.4.10
--- moodss 20.3 ------------------------------------------------- 2005-07-23 ---
- in moodss GUI:
  - in real time mode, viewers displaying or requiring data cells history, such
    as graphs and statistics tables, now store and reuse their data cells
    histories, so that, for example, when mutating a graph viewer to a stacked
    graph chart, the plots do not restart at the current time
  - database range dialog box now includes a calendar entry widget with days
    range selection possible using the shift key
  - when mutating viewers, new viewer options match preferences and dashboard
    configuration
  - improved font preferences and initialization by using sizes in points
    instead of pixels
  - on Windows platforms, fonts are based on actual global font choice, as
    picked from the control panel
  - on UNIX type platforms, text entries and listboxes selection foreground is
    no longer forced to black
  - when erasing a newly created sole peer table, an error would occur
  - in configuration, preferences and database load dialog box, tree selection
    foreground is now white on UNIX platforms, as it is already on Windows
  - when deiconifying a module table, properly set status color as title
    background from current icon color
- in nagios module:
  - when plugin full path is used, do not check for check_ header
  - detect -H host option in plugin command and use it in identifier
  - added --identifier option to force module table titles
- updated mystatus module for MySQL 4.1.13 support
--- moodss 20.2 and moomps 5.2 ---------------------------------- 2005-07-01 ---
- in moodss GUI:
  - added View/Objects menu with tables and viewers as sub-menu entries so the
    selected object can be immediately found and brought to front no matter
    whether it is hidden by other objects or in another page
  - fixed source code typo which prevented opening dashboards containing
    database data
- in psbyname and psbyuser modules, take processes shared and unshared memory
  into account for more realistic results, whereas the sum of all memory used is
  no longer vastly greater than the actual available memory
- in moomps daemon, create process ID file early (--pid-file option) instead of
  after initialization of modules, which may take a long time
- in randpy example Python module, use random instead of deprecated whrandom
  Python module and removed stray debug print statement
- in standalone binary:
  - added moomps daemon, but with foreground support only (-f option)
  - upgraded Tcl/Tk to 8.4.10 from 8.4.9
- in moomps daemon initialization script, in chkconfig configuration, do not
  start by default and changed priorities (same as hddtemp daemon)
- in the FAQ HTML documentation, added post-mortem analysis example
- in included C helper libraries, removed a few warnings reported by gcc 4
- successfully tested with Tcl/Tk 8.4.11
--- moodss 20.1 and moomps 5.1 ---------------------------------- 2005-05-26 ---
- in moodss GUI:
  - when only peer tables and other viewers, but no modules, were saved in a
    dashboard, application would crash due to the lack of an internal poll time
  - in preferences dialog box, in application database page, added "no database"
    (none) choice
  - slightly reduced code size by completely removing daemon related code
  - in rpm for Red Hat Fedora, now require sqlite2-tcl as it is available in
    both Fedora Core 3 and 4 extra packages repository
- in moomps daemon:
  - changed default dashboard (data) directory from /etc/moomps to /srv/moomps
    in order to comply with the Filesystem Hierarchy Standard
  - just warn, do not report error when there is nothing to do to avoid making
    the user think that the daemon has aborted
  - do not create a SQLite database file by default in home directory unless
    specified via moodss preferences interface
  - ignore failures on exit when deleting process ID file
  - reduced code size and therefore memory footprint by completely removing
    unused GUI related code
  - in HTML documentation, fixed links to sections in moodss HTML documentation
- in system module, when remotely monitoring, module identifier (table title)
  did not include host name
- continued to remove pre 8.4 Tcl/Tk code and optimize using latest Tcl/Tk
  commands
--- moodss 20.0 and moomps 5.0 ---------------------------------- 2005-05-08 ---
- implemented distributed monitoring feature whereas moodss or moodss can
  act as a server or client for exported data:
  - added File/Peer menu with Export and Import sub-menus
  - added new tables for displaying exported and imported data, and which
    act as any other table for dropping cells in viewers, thresholds, ...
  - added dialog boxes with server host and TCP port input
  - implemented so that future extensions, such as peer data transfers
    between clients and web browser support as client are possible
  - many thanks to Nicolas Gagnon and Daniel Savard for their suggestions,
    support and help testing this new feature
- dropped Tcl/Tk 8.3 version compatibility: Tcl/Tk 8.4 or above now required
- started to remove pre 8.4 Tcl/Tk code and optimize using latest Tcl/Tk
  commands
- in moodss GUI:
  - prevent errors when browsing SQLite database while another process is
    recording in the same database
  - prevent loading internal instance module via command line
  - in some cases, active thresholds on formulas viewers data cells would not
    result in page tabs changing colors
  - error and warning messages coming from modules and meant to remain visible
    for a while (flash) are no longer prematurely erased by update messages
  - in some cases, the widget tip for the record button in the tool bar
    erroneously displayed that there were no cells to archive (thanks to
    Daniel Savard for his patch)
  - when erasing a row from a statistics table, viewers monitoring data cells
    belonging to that row were not always showing related values as void
- the moomps daemon failed to archive formula data cells in database and now
  does
- in dashboard files, internal rows of current value tables are saved in a list
  in true XML fashion
- in database, values of options of password type are stored as a single *
  character and their value ignored when recording, which prevents erroneously
  creating multiple database instances of a module when only a password type
  option value is changed
- for databases other than SQLite, added index on options table in order to
  improve performance with big quantities of data
- for Oracle database, also prefixed history table index name to avoid conflicts
- updated myvars and mystatus modules for MySQL 4.1.11 support
- made cpustats a 64 bit module and fixed it so that 64 bit counters in
  /proc/stat are properly handled
- for Python modules programmers:
  - added support for tclpython version 4 library (used in Python modules)
  - support threaded Perl modules if tclperl version 3.1 library is available
  - implemented message utility functions (tclpython version 4 required):
    flashMessage(), pushMessage(), popMessage(), traceMessage() and after()
    (thanks to Daniel Savard)
  - in development HTML documentation, documented new message and timer
    functions available from Python
  - dictionaries are now supported, on top of arrays, for holding row data,
    which is obviously much more practical (thanks to Daniel Savard for his
    patch)
- on 64 bit machines, abort moodss or moomps if Tcl version is not at least at
  8.4.8, as a bug otherwise prevents proper long integers conversion
- updated nagios module documentation
- in database HTML documentation, specified how concurrent accesses are managed
  with SQLite
- in standalone binary, included SQLite 3.2.1
--- moodss 19.7 and moomps 4.6 ---------------------------------- 2005-02-22 ---
- in moodss GUI:
  - fixed bug, introduced in 19.6 release, which prevented database browsing
  - implemented state colors for modules, displayed as title background color in
    their tables or icons: green for valid data / idle, gray when in the process
    of updating, red for error(s) at the last update (not available for modules
    written in Python)
  - in thresholds dialog box, when deleting a row, the "active" and "once"
    states of the rows below were incorrectly refreshed (they remained correct
    internally)
  - formulas could not handle cells from statistics table
- in statistics table, added standard deviation column
- slightly modified moodss Makefile for FreeBSD compatibility (attention SunOS
  users: resolving library must now be specified)
--- moodss 19.6 ------------------------------------------------- 2005-02-13 ---
- added nagios module, which can use any plugin from the Nagios monitoring
  software, with automatically preset thresholds, extending the number of
  potential moodss modules to a total of about 100 in the process
- in moodss GUI:
  - also allow minimum value (both fixed and dynamic as dropped from a data
    cell) in following viewers: graph, overlap bar and side bar charts viewers
  - for graphs and stacked graphs viewers:
    - added the ability to choose the plot background color and whether a grid
      is displayed, in preferences and in dashboard configuration
    - added grid entry in popup menu to allow grid setting per graph
    - in the lower right cell of displayed module data tables, the widget tip
     (balloon) would sometimes fail to display
  - prevent internal instance and formulas modules from being listed as
    loadable and loadable from command line
- implemented FreeBSD compatibility for the following modules: cpustats,
  memstats, mounts, ps, psbyname and psbyuser (many thanks to Ira Lee for his
  support)
- in all remote capable modules:
  - added -p port option for remote monitoring with ssh
  - made scripts used for remote monitoring compatible with sh Bourne shell,
    so that bash is no longer required
- in all MySQL modules, fixed mysqlinfo bug that occured when mysqltcl library
  version 3 was used
- in formulas documentation and help, last(), diff() and delta() documentation
  is also available in Japanese
- in ps module, in command line column, "c" characters were wrongly stripped
- in ps, psbyname and psbyuser modules, gracefully handle invalid remote data,
  such as generated by echo statements in a user's .profile, for example
- in mounts modules, fixed remote monitoring for Linux (via rsh or ssh, bug
  introduced in 19.4 moodss release)
- added Log sample Perl asynchronous module, using threads to monitor a log file
- fixed standalone binary, which lacked tktable library
--- moodss 19.5 and moomps 4.5 ---------------------------------- 2005-01-04 ---
- in formulas, added the following functions:
    - last(): value of a data cell at last formula update time
    - diff(): floating-point difference between data cell current value and
        value at last formula update
    - delta(): integer difference between data cell current value and value at
        last formula update
    - diff(time): time since last update (floating-point value in seconds)
  (please test them and report any problem at http://moodss.sourceforge.net)
- all formulas are now only updated when refreshing occurs (every poll time
  interval) instead of when any composing data cell value changes, in order to
  avoid useless updates and improve performance (note: also check formulas
  documentation for the special case of data coming from asynchronous modules)
- updated myvars module for MySQL 4.1.8 support
- added support for mysqltcl MySQL interface library version 3
- in diskstats modules, fixed remote monitoring (via rsh or ssh, bug introduced
  in 19.4 moodss release)
--- moodss 19.4 and moomps 4.4 ---------------------------------- 2004-12-17 ---
- added new psbyuser module, analogous to the ps module but with data aggregated
  by user
- in interrupts, memstats, mounts and sensors modules, used optimized
  non-blocking implementation, using events or threads
- in sensors module, added --path option
- in all remote capable modules (including the pci module reference
  implementation), specifically handle invalid data when remotely monitoring, so
  that all errors can be thoroughly detected in ssh mode
- in smithy module, fixed bug caused by a typo, no longer require smithy version
  2.1 so that it also works with 3 versions, removed now unneeded --keyfile
  option
- in shipped linux dashboard, added processes page with psbyname and psbyuser
  modules
- in standalone binary, upgraded Tcl/Tk to 8.4.9 from 8.4.7
- updated manual pages
- successfully tested with Tcl/Tk 8.4.9
- successfully tested on Red Hat Fedora Core 3 (with selinux targeted policy)
--- moodss 19.3 and moomps 4.3 ---------------------------------- 2004-11-15 ---
- added new psbyname module, analogous to the ps module but with data aggregated
  by process name
- in moomps daemon:
  - now reports any problems with dashboard files and directories passed as
    arguments, in the foreground (before forking), so that such errors can be
    immediately detected
  - use more explicit error messages, with hints
- in route module, also determine processor byte ordering (endian type) for
  remote machines
- in netdev module, set 64 bits flag since internal row numbers are 64 bit long
  (therefore a 8.4 or above Tcl core is needed)
- in ps module:
  - used new non-blocking implementation, using events or threads
  - memory usage in percent was slightly overvalued
- in order to avoid faulty Tcl packages crashing the core, moodss attempts to
  dynamically load packages only if they are located in a moodss directory,
  except when in debugging mode (--debug command line switch)
- successfully tested with mysqltcl MySQL interface library version 2.51
--- moodss 19.2.2 and moomps 4.2.2 ------------------------------ 2004-10-31 ---
- in moodss GUI, hopefully completely restored Tcl 8.3 core compatibility
- updated myvars module for MySQL 4.1.7 support
- slightly improved rpm specification files according to rpmlint output
- made moomps daemon init script pass rpmlint test
- successfully built and tested on 64 bit architecture (patched BLT required)
--- moodss 19.2.1 and moomps 4.2.1 ------------------------------ 2004-10-30 ---
- restored Tcl 8.3 core compatibility, erroneously lost in moodss 18.4 and
  moomps 4.0 versions (if you are not using Tcl 8.4 or 8.5, please make sure
  to report any such bug at http://moodss.sourceforge.net/)
- in moodss GUI, made sure initial font is readable even on very high resolution
  screens
- allowed rpm package to build on 64 bit architecture
--- moodss 19.2 and moomps 4.2 ---------------------------------- 2004-10-25 ---
- added support for SQLite 3 database library, which, if present, is now loaded
  before trying SQLite 2
- default preferences for database storage is now SQLite with moodss.dat file in
  user home directory as storage file
- in standalone binary, included Tktable 2.9 and SQLite 3
- in moodss rpm specification file, generated shared libraries are no longer
  stripped so that debug rpm is properly generated, and sqlite package is now
  required
- updated myvars module for MySQL 4.1.6 support
--- moodss 19.1 and moomps 4.1 ---------------------------------- 2004-10-17 ---
- in moodss GUI:
  - added sub-menu in popup menu for graphs and bar charts viewers to choose
    which side the data cells labels should be placed relative to the graphics
  - in preferences and dashboard configuration, in viewers graphs section, added
    default choice for side of data cells labels
  - unexpected command line options could result in a source code trace printout
    instead of a more elegant error message
  - in configuration dialog box, in application background section, tabs of
    pages, when placed at bottom were clipped: fixed using BWidget bug fix
  - in Windows zip distribution, forgot to include formulas module sub-directory
  - on UNIX platforms, slightly improved looks of dialog boxes by using white
    backgrounds in entry fields and spin boxes
  - removed a small memory leak in all scrollable objects
  - eliminated infinite oscillations in rare cases where some displayed tables
    were resized too small
  - successfully tested with Tktable 2.9
  - Japanese help updated
- a module failing to load due to a fatal error could disturb the configuration
  of thresholds or database storage on cells belonging to other modules, if the
  module in error had itself cells set in thresholds or in database storage
  (note: fixed using additional data in dashboard file, so save over existing
  dashboard if in doubt)
- formulas documentation and help was translated in Japanese, thanks to
  KITAHARA Kosei
- for Perl modules programmers:
  - added support for tclperl version 3 library (used in Perl modules)
  - support threaded Perl modules if tclperl version 3.1 library is available
  - implemented message utility functions:
    flashMessage(), pushMessage(), popMessage(), traceMessage() and after()
  - in development HTML documentation, documented new message, timer and threads
    functions available from Perl
- added Threaded sample Perl module using threads
- in Perl Random module, added -a (--asynchronous) option as in original random
  module
- in snmp and smithy modules:
  - big tables could make internal hashing code fail
  - when monitoring identifiers (not tables), displayed tables remained empty
    after network failure followed by recovery
- in myhealth, mystatus and myvars modules for MySQL, added support for 4.1
  servers versions
- updated myerrorlog module for MySQL 4.0.21 server support
- no longer support dashboard files created with moodss prior to version 17.7
- includes md5, uri, base64, smtp and mime source from new tcllib 1.7 release
--- moodss 19.0 and moomps 4.0 ---------------------------------- 2004-09-12 ---
- added the capability to create mathematical formulas from any number of data
  cells belonging to any number of modules, including data cells from formulas
  tables
- added new viewer type: formulas tables, the data cells of which can be dragged
  and dropped and used as any other data cells from module tables and viewers
- slightly changed internal format in dashboard files for the first instance of
  a module (in order to support internal formulas modules)
- implemented conversion code for loading dashboard files created by moodss
  before version 19 (please make sure to report any problem in
  moodss.sourceforge.net bugs section)
- removed compatibility code for reading dashboard files and preferences in old
  data format (before moodss 16.8) (use moodss 18.4 if you need to convert old
  data files to the new format, by loading the file than saving over it, or
  email the file to me for conversion)
- in moodss GUI:
  - added formulas viewer creation entry in Edit/New viewer menu
  - added formulas dialog box for editing new or existing formulas from formulas
    tables
  - implemented saving and restoring formulas tables
  - added specific help (from new formulas.htm HTML file) for mathematical
    expressions and syntax in formulas
  - window size saved in dashboard files is no longer the main window size but
    rather the size of the work area, which make the display consistent, whether
    the tool bar, drag and drop area, ... are displayed or not (note: this may
    require adjusting the size of existing dashboard and saving them again)
  - added tool bar icons in main window menu entries (compound menus feature as
    in KDE, Gnome, ...)
  - cases when scrollbars would be displayed when not really needed (happened
    especially with pages) are now filtered out
  - remember valid images directory for background images and iconic viewers
  - some global variables, such as application printing, database and trace,
    thresholds email and trace, and daemon resource file, were not immediately
    updated, but only after an application restart (bug introduced in 18.4)
  - in thresholds dialog box, script and test trace areas were not cleared when
    a threshold entry was deleted
  - any error in command line arguments would result in an error trace being
    printed instead of the usual help usage message
  - in some cases, display of widget tips (balloons) would fail in displayed
    module data tables, when cells in the rightmost column are clipped and
    scrolled at the same time
  - changed toolbar icon for dashboard configuration
  - in menus and toolbar strings and help text, use "dashboard" instead of
    "configuration" for file save operations, and "record" in database archiving
    related operations
  - wrongful changes detection could occur in dashboard files with thresholds
    so that the user would be incorrectly asked to save the dashboard file on
    application exit
  - in modules dialog boxes (launched from File/Modules menus), do not display
    internally used --daemon option in interface
  - in free text viewers, initial help message would remain for a while even if
    viewer was not empty
  - when loading a dashboard with recordable data cells (in database), the
    record button was wrongly kept disabled in both the toolbar and the
    File/Database menu
  - in displayed tables, reselecting a single cell after a cell was selected in
    another table would not restore the sunken relief on the cell
  - in database browsing mode, dropping a statistics table cell, other than the
    current value, into a values table, would result in an application error
  - in error dialog, use nicer looking icon from KDE
  - new thresholds then cancelled resulted in an incomplete release of internal
    resources
  - disabled Edit/New viewer when main window is empty
  - internationalized a few user interface related text strings that were
    forgotten in previous releases
  - in database history mode, flash message when attempting to drop cells not
    coming from a module instance data table into a values or statistics table
  - in preferences dialog box, in application database section, set default
    values for host and database when MySQL is selected, data file when SQLite
    is selected
  - moved FAQ section out of run-time help to separate HTML document
  - removed useless --tabs option from command line options
- made sure that collisions never occur between modules and namespaces used
  internally
- in moodss daemon, added formulas tables handling
- added formulas.htm and formulas-ja.htm HTML help files in distribution
- added formulas as a reserved module name
- in route module, destination, gateway and mask data were treated as data with
  little endian byte ordering no matter what the platform was, which was wrong
  on s390 mainframes
- in snmp and smithy modules, 127.0.0.1 was used in titles of displayed tables
  even though a different address was set using the --address option
- in MySQL myhealth module, use Threads_connected variable instead of
  Max_used_connections to calculate the exact remaining connections
- in the moodss HTML documentation, some HTML header tags were off by one
- added formulas and FAQ HTML documents to moodss distribution
- added japanese version of moodss HTML documentation to moodss installation
- in standalone binary, upgraded Tcl/Tk to 8.4.7 from 8.4.6
- successfully tested with Tcl/Tk 8.4.7
--- moodss 18.4 ------------------------------------------------- 2004-07-11 ---
- in moodss GUI:
  - in configuration dialog box, or via popup menu, background images can be set
    for the main window or per page
  - background images are saved and restored from dashboard files
  - iconic viewers now feature a popup menu for changing the icon image
  - in displayed module data tables, when cells in the rightmost column are
    clipped, widget tips (balloons) show cells full content when mouse cursor is
    placed over clipped cell
  - the preferences, when modified, are not immediately taken into account, but
    rather when the application is restarted
  - in the preferences dialog box, all Apply buttons have been removed
  - when opening another dashboard, background color, if any, was not updated
  - on windows, images in the global help did not show
  - when changing cells configuration from the configuration dialog box, labels
    of iconic viewers were not updated (module identifier displayed or not)
- removed SQLite library from moodss rpm package, as the SQLite library is
  available in the stable repository for Fedora (in
  http://download.fedora.us/fedora/fedora/1|2/i386/RPMS.stable/: sqlite and
  sqlite-tcl rpms)
- includes SQLite 2.8.14 libraries in standalone binary and Windows
  distributions
- in homepage, added screenshot of dashboard with background image, iconic
  viewers and Japanese text (http://moodss.sourceforge.net/moodss11.gif)
- successfully tested on Red Hat Fedora Core 2 with stock tcl, tk and tclx
  packages, blt and tktable packages from stable repository
--- moodss 18.3 ------------------------------------------------- 2004-06-13 ---
- in moodss GUI:
  - in configuration or preferences, validating choices would fail if
    application sizing was set to automatic
  - dropping an iconic viewer with no monitored data cell into another viewer,
    drop site, would cause an error
  - iconic viewers without data cell, or new iconic viewers that were never
    moved from upper left corner, are now properly restored from dashboard file
  - pressing Control key while moving or resizing tables or viewers disables
    magnetic attraction to aid in fine positioning
  - viewers circulation (using Tab and Shift-Tab) now also handles minimized
    tables (icons) and iconic viewers by highlighting them with a black border
    (even if they are hidden by other objects)
  - updated Japanese translations related to iconic viewers
  - re-minimizing tables from a dashboard file would result in a different
    positioning for the icon
- updated myerrorlog module for MySQL 4.0.20 support and included 1 missing
  error message
- on windows, due to a bug in tclodbc, checking database 64 bits compatibility
  is disabled
- in moodss HTML help documentation:
  - updated Japanese translations related to iconic viewers
  - updated a few screen shots, with new icon theme
--- moodss 18.2 and moomps 3.2 ---------------------------------- 2004-06-01 ---
- in moodss GUI:
  - added a new viewer type: iconic, which allows associating a data cell with
    an icon (GIF file chosen by the user), whose background color changes
    according to threshold setting on the data cell (will become even more
    useful when it is possible to use background images, such as maps, in
    dashboards)
  - icons (minimized tables) are now strictly restricted to canvas area when
    moved, and can now reside in pages other than the first
  - tables and viewers are now strictly restricted to canvas area when moved
  - icons (minimized tables) can now be dropped in other pages (via page tags)
  - when moving icons (minimized tables), coordinates are displayed in message
    area
  - in about dialog box, added license for KDE Crystal theme icons
  - minimized tables are now restored properly, even in a page other than the
    first, from a dashboard file
  - default sizing mode is now automatic
  - when main window is resized, scroll bars are adjusted so that all tables,
    viewers and icons remain reachable
  - when main window width was greatly reduced, message header text could
    disappear
  - in help and about dialog boxes, use a white background
- in distribution, included Japanese documentation for moomps
- included Japanese HTML documentation in Windows zip distribution
- the Japanese help and HTML documentations were improved
- updated myvars module for MySQL 4.0.20 support
- sources and project management now hosted at SourceForge
  (http://sourceforge.net/projects/moodss/), to benefit from the great bugs,
  patches, ... and other tracking systems and utilities
--- moodss 18.1 and moomps 3.1 ---------------------------------- 2004-04-25 ---
- in moodss GUI:
  - completely internationalized text in user interface (menus, dialog boxes,
    help tips, ...) (developed and tested on UNIX only, with Tcl/Tk 8.4.6 and
    8.5, may work on Windows)
  - added complete Japanese translations (use LANG or LC_ALL = ja environment
    variables), including HTML help, thanks to SENRI Hiroshi (note: input has
    not been fully tested, although it works with canna, kinput2 and X Input
    Method Protocol: please report any problems)
  - added complete french translations (use LANG or LC_ALL = fr), but excluding
    HTML help which remains in English
  - when initializing from a dashboard file, some viewers would fail to properly
    display data cell labels if data cells came from a statistics table
  - in thresholds dialog box, email addresses are now checked and errors
    reported when the test button is pressed
  - free text viewers could wrongly be edited in read-only mode
  - message widget string ("Message:" by default) no longer saved in dashboard
    files
  - binary distribution includes patched version of Tcl/Tk 8.4.6 so that
    maximize button is available in a KDE 3.2 environment
- included Japanese HTML documentation in distribution
- in random module, added HTML help in Japanese.
- successfully tested Japanese support in SQLite and MySQL (native and ODBC)
  databases (using Japanese comments in data cell entries)
- in internal database code, in ODBC mode, 64 bits compatibility check between
  data and history tables was incorrect
- in global HTML help, added internationalization section and FAQ entry for
  Japanese support with input
- in thresholds code, detect and report empty SMTP servers list when trying to
  send emails
- in dashboard and preferences files, included encoding field in XML header, as
  generated by Tcl (default -> utf-8, fr -> iso8859-1, ja -> euc-jp)
- in development HTML documentation, added internationalization section
- in kernmods, mounts, ping, sensors, snmp and smithy modules, slightly improved
  code efficiency using Tcl 8.4 features
- documented Tcl/Tk 8.4 or above requirement in the HTML help of modules that
  internally use 64 bit row numbers
--- moodss 18.0 and moomps 3.0 ---------------------------------- 2004-04-07 ---
- started to progressively abandon Tcl/Tk 8.3 version support, as 8.4 had been
  stable for a long time and is now available on most platforms and
  distributions (the moodss GUI and moomps daemon core will remain compatible
  with Tcl/Tk 8.3 for several months, with only a few modules requiring Tcl/Tk
  8.4 or above at this time)
- added full 32 or 64 bits support (even on 32 bits CPUs):
  - if core is running under Tcl/Tk 8.3, implemented full unsigned 32 bit row
    numbers support (row numbers were limited to 31 bits before)
  - if core is running under Tcl/Tk 8.4 or above, implemented full unsigned 64
    bit row numbers support
  - in internal database code:
    - when creating data and history tables, use 64 bits compatible type for
      "row" column when running under Tcl/Tk 8.4 or above
    - at startup time, check that database format is compatible with Tcl/Tk
      version used in the core (moodss GUI or moomps daemon)
    (please read database HTML documentation for complete information)
  - in random module, use large 32 bits unsigned row numbers as example, or 64
    bits under Tcl/Tk 8.4 or above
- in development HTML documentation:
  - added specific section on row numbering and its different techniques
  - added utilities section, with hash and non-blocking channel libraries
    sub-sections
  - documented new 64Bits and persistent module data configuration members
- added "64 bits support" and "upgrade from moomps before 3.0" section in
  database HTML documentation
- used new non-blocking implementation, using events or threads, for the
  following modules: arp, cpustats, disks, kernmods, netdev, route, system
- made kernmods module compatible with Linux kernel 2.6 (on top of 2.4)
- in snmp and smithy modules, when retrieving a table from the remote agent,
  wait until all the columns have been retrieved before processing the data, so
  that holes (cells missing from one or several columns) are properly displayed
- modules changed to use 32 bits unsigned numbers as row indexes
  (incompatibility with existing dashboards including viewers, thresholds or
  database archiving):
  - arp and route (row calculated from IP addresses)
  - disks and diskstats (row calculated from device as defined in Linux kernel)
  - usb (row calculated from bus and device numbers)
  - interrupts (row equal to interrupt number or generated from interrupt name)
  - pci (row generated from bus, device and function)
- modules changed to use 64 bits unsigned numbers as row indexes
  (incompatibility with existing dashboards including viewers, thresholds or
  database archiving):
  - sensors (row generated from sensor name)
  - kernmods (row generated from module name)
  - mounts (row generated from directory name)
  - netdev (row generated from interface name)
  - ping (row generated from host name or IP address)
  - snmp and smithy (row generated from SNMP object sub-identifier)
- in moodss GUI:
  - in toolbar, use nicer looking icons (based on the KDE Crystal SVG design)
  - when archiving data in database, stop button is lit in red
  - when browsing data from database, play button is lit in green
  - allowed mouse wheel use on scrollbars, help dialog boxes, displayed data
    tables and various list boxes
  - in thresholds dialog box, improved loading time when there are many
    thresholds, at the expense of display correctness while loading
  - in thresholds, when trying to open a dashboard while an active threshold
    existed no longer results in a core error
  - added support for Tcl/Tk 8.5 by fine tuning internal fonts sizing
    (graphs and barcharts viewers do not work yet though)
  - configuration files (dashboards) are now opened and written to disk as
    quickly as possible to prevent moomps daemon from getting incomplete data
  - dashboards including current values table viewers would fail to load
  - mutating a viewer (via drag and drop) to a  current values table viewer
    would fail
  - in edit database dialog box, an error could occur if recording was
    previously attempted while no data cells were set to be archived
  - in most viewers and edit database dialog box, cell labels were not updated
    as they should have been when cell data value was void
  - in pie viewers, total cell arrow color turns gray if total cell data value
    is void
  - and graph and bar chart viewers, maximum value was sometimes invisible when
    void
  - in generic file dialog box, use nicer looking icons when running under
    Tcl/Tk 8.4 and above
  - in general and modules help windows, use an iconic instead of textual close
    button
  - file/database/start menu and associated tool bar record button are enabled
    or disabled based on the edit/database dialog box contents
- in the moomps daemon, threshold scripts errors are now written to the log
- when using custom thresholds messages, allow an empty body but not an empty
  subject
- in all remote capable modules using the new line task implementation, removed
  potential race condition which could happen if user keeps refreshing at
  maximum rate from the GUI core (Control-R key stuck)
- updated myerrorlog module for MySQL 4.0.18 support
- in arp module, use more exhaustive Ethernet manufacturers file from Ethereal
  project
- in moodss Makefile:
  - use separate -s and -f options with ln command to make it compatible with
    Solaris 8
  - check Tcl stubs library presence so that building under Redhat 8.0 works
- updated install.txt (for Windows) with latest various extensions versions and
  added mysqltcl reference for MySQL database access
- includes md5, uri, base64, smtp and mime source from new tcllib 1.6 release
- in standalone binary, upgraded Tcl/Tk to 8.4.6 from 8.4.5
- successfully tested with Tcl/Tk 8.4.6
- includes latest SQLite 2.8.12 libraries
- successfully tested with mysqltcl MySQL interface library version 2.50
- developed and tested on Red Hat Fedora Core 1 with Linux 2.6.5 kernel
- note: moodss 17.17 seems available for Debian now
--- moodss 17.17 and moomps 2.19 -------------------------------- 2004-02-08 ---
- in moodss GUI:
  - in thresholds dialog box:
    - added mail message section, optionally visible, which allows user defined
      email messages (subject and body) to be used in place of the default
      message (as defined in preferences)
    - added initial condition check button so that no action is taken at
      application start even if condition is met (see HTML documentation for
      details and example)
    - made script and test areas optionally visible
    - moved delete and test buttons to the bottom
    - in action column, a yellowish (instead of white) envelope icon is used to
      show a customized email message has been specified
    - underlined first letter of delete and test buttons as a reminder of
      bound accelerator keys
  - in preferences thresholds email section, added default message subject line
    and body text entries
  - global help data is dynamically loaded only when needed in order to reduce
    startup time and memory footprint
  - when loading a database dashboard from the File/Open menu, the thresholds
    drop site was erroneously enabled
  - in database dialog box, added Alt-d keyboard accelerator for Delete button
- in UNIX makefile, no longer use -i sed option as it is not supported on
  Solaris, use use symbolic linking to be able to cross filesystems for Tcl
  stub library
- in modules HTML documentation file, added a short introduction for each
  included module
- in development HTML documentation, added threads and events programming
  section, pointing to the pci module as reference implementation
--- moodss 17.16 and moomps 2.18 -------------------------------- 2004-01-19 ---
- upgraded pci module in a major way in order to serve as a reference for all
  remote capable modules that communicate to a remote machine via a remote
  capable shell program:
  - fully documented using exhaustive comments in the source code
  - uses new line task class for maximum reliability while trying hard to never
    block the application in case of problems in remote monitoring mode
  - when using ssh for remote monitoring, open one session only in order to
    improve performance
  - added -C (compression) and -i (identity file) options for ssh on UNIX
    clients
  - restricted remote monitoring option to ssh://session syntax on Windows
    clients (using putty software which does not support rsh in non interactive
    mode)
- added diskstats module for Linux, compatible with both 2.4 and 2.6 kernels,
  and which will eventually replace the partitions module, only compatible with
  2.4 kernels
- added usb module for Linux (using lsusb command which must be available)
- added hddtemp (hard disk drives temperature) module for Linux (using hddtemp
  command which must be available)
- in pci module, use lspci command instead of /proc/pci file, rendered obsolete
  in Linux kernel 2.6
- in cpustats module, added iowait, irq and softirq columns so that Linux kernel
  2.6 can be supported
- moved modules and development sections out of moodss.htm HTML documentation
  into modules.htm and develop.htm separate files
- in predefined dashboard included in rpm package for Linux, disabled the
  display of module headers on the labels of the data cells in the different
  viewers
- in rpm package, use a shorter name (moodss) in the system tools menu entry
- in moodss makefile, handle non versioned Tcl stub library when building
  dynamic libraries (happens of Red Hat 9)
--- moodss 17.15 and moomps 2.17 -------------------------------- 2003-12-29 ---
- in moodss GUI:
  - when saving configuration in database history mode, the database instances
    viewer position, size and icon status are now also saved and restored
  - in preferences and configuration dialog boxes:
    - added viewers cells section, in which the user can choose whether module
      names or identifiers are displayed in cell labels in viewers (which is
      useful for example when there is only one module loaded)
    - added viewers tables section, in order to be able to set the maximum
      number of rows of values table in database history mode
    - in viewers graphs page:
      - add X axis labels angle setting between 45 and 90 degrees
      - added apply button in order to dynamically apply options to existing
        graph viewers
      - in database history mode, number of samples entry is grayed
    - application size page would crash due to a bug introduced in the previous
      release (a typo in the source code really)
  - in statistics tables viewers, data cells labels were incorrect (bug
    introduced in previous release)
  - when loading general help window, display watch cursor in top contents pane
    till bottom pane is fully rendered
  - added help message in empty database instances viewer suggesting to load
    module instance(s) from database or perform a drop
  - in some cases, when reloading a database history dashboard with viewers, an
    error could occur, caused by the database being disconnected and the viewers
    trying to update just before being deleted
  - pie viewers would crash when a threshold was set on one of their data cells
- in pci module, removed detailed information column (too verbose and technical)
- updated myerrorlog module for MySQL 4.0.17 support
--- moodss 17.14 and moomps 2.16 -------------------------------- 2003-12-24 ---
- in moodss GUI:
  - allow saving configuration (in a .moo file) in database history mode, so
    that building database based dashboards is possible
  - in history (database browsing) mode, automatically disconnect from database
    when instances viewers is destroyed
  - when a module is updated or periodically updating, no longer set the mouse
    cursor to a watch as that seems to eat X Window server memory (on Linux at
    least)
  - in database history mode, in module instance table, displayed values were
    not limited in time by leftmost instant cursor
  - made configuration and preferences dialog boxes tree look closer to standard
  - uses newest BWidget 1.7.0 release
- in moomps daemon:
  - disallow and report error when configuration file(s) contain(s) database
    instance modules
- in partitions module, number of kilobytes read or written was based on
  incorrect values in /proc/partitions file (should be fine now provided disk
  sector size is 512 bytes, as it seems to be always the case with 2.4 and above
  kernels)
- upgraded myvars module for MySQL 4.0.17 support
- when installed as a rpm, the System Tools/Monitoring menu now launches moodss
  with a predefined dashboard for linux, including CPU, memory and mounted
  file systems statistics
- included sample dashboard for Linux in moodss tarball (linux.moo)
- made tclodbc, tclperl and tclpython rpms for Red Hat Fedora Core 1 available
  on homepage
--- moodss 17.13 and moomps 2.15 -------------------------------- 2003-12-13 ---
- in moodss GUI:
  - in graphs, pies and bar charts viewers, added popup menu (on mouse button 3)
    so that cell data displayed color can be customized
  - in database browsing mode, current values table display data cell history
    with date and time in left column, limited to the last 1000 rows
  - in configuration files (.moo), store displayed data cell colors in graphical
    viewers
  - renamed current values table to values table
  - no longer use BLT busy command to show that the application is busy (the
    watch cursor is still displayed) as that caused huge memory usage by the X
    Window server in the long term, and prevented some events (such as drag and
    drop, buttons, ...) from reaching their owner (thanks to Serge de Souza for
    reporting this bug)
  - maximum value on graph and bar charts viewers was not initially displayed
    when coming from a save file
  - in internal window manager, added extreme right and bottom sides of canvas
    to magnetized regions
  - in read only mode (-r command line option), disable maximum, total and
    colors popup menus in graph and pie viewers
- in moomps daemon:
  - greatly improved reliability, by catching unexpected errors in modules so
    that the core is not halted by a faulty module
  - write all errors in modules to log, along with error trace in debug mode
- in memstats module, added support for 2.6 Linux kernel
- in moodss rpm specification file, added Tcl and Tk include files in build
  requirements
- successfully tested with Tcl/Tk 8.4.5
- in standalone binary, upgraded Tcl/Tk to 8.4.5 from 8.4.4
- documented new Red Hat and Fedora blt rpms availability
- updated nmicmpd (used by ping module) rpm and spec file (see homepage)
- built and successfully tested on Red Hat Fedora Core 1
--- moodss 17.12 and moomps 2.14 -------------------------------- 2003-11-15 ---
- in moodss GUI:
  - implemented windows (tables and viewers) snapping (KDE style) in the
    internal window manager, so that windows (when moving) or their borders
    (when resizing) seem to be magnetically attracted to other windows or canvas
    borders
  - in free text viewers, Control-C, Control-V and Control-X now work as
    expected
  - in thresholds dialog box:
    - Control-C, Control-V and Control-X now work as expected between entries
      (useful for copying scripts text from one entry to another)
    - increased value column default width to handle large numbers
  - hiding tool bar via View menu would make application crash
  - in thresholds dialog box, added Alt-t and Alt-d keyboard accelerators for
    Test and Delete buttons
  - removed icon in about dialog box
  - saving preferences could result in a crash if initialized from an old
    .moodssrc file (problem in database section)
  - when printing, improved printing command error handling
  - when moving tables or viewers in a page other than the first one, the X axis
    coordinate displayed in the message area was incorrect
- in snmptrap module, always place last event at row index 0 to improve
  threshold usefulness and storage in database history (see module HTML
  documentation)
- improved moodss and moomps rpm packages using rpmlint and experts advice for
  inclusion in Red Hat Fedora Linux distribution
- in rpm source package, changed group to Applications/System
- when installing with rpm, a system tools menu entry is created (verified on
  Red Hat) with a new icon
- when upgrading moomps with rpm, perform a conditional restart of the daemon
- split moodss tarball in 2 with a specific tarball for the moomps daemon
- upgraded myvars and myerrorlog modules for MySQL 4.0.16 support
- added reload command to moomps initialization script
- in Makefile:
  - changed init directory default to /etc/rc.d/init.d for moomps
  - added generation of default moomps daemon resource file
- in moomps daemon, when running in foreground, print day and time as header in
  log messages printed to terminal
- in moodss documentation, split viewers section into sub-sections by viewer
  type
- in log module, slightly improved remote error handling
--- moodss 17.11 and moomps 2.13 -------------------------------- 2003-10-20 ---
- thresholds code can now handle invalid data, such as non numeric data for
  supposedly numeric type cells, by falling back to dictionary type strings
  comparison
- thresholds conditions are now only checked after module(s) data becomes valid
  once the module is loaded
- in database data table, no longer store module identifier header in label
  column data to avoid redundancy, as module identifier is already known from
  module instance (INCOMPATIBLE change)
- in moodss GUI:
  - allow maximum value in all graph type viewers: graph, stacked graph,
    overlap bar, side bar and stacked bar charts
  - in database browsing mode, no longer display module identifier header in
    column labels to avoid redundancy in generated viewer labels
  - in graph type viewers, maximum value arrow is now placed in the axis
    graduations area instead of the plot area
  - in thresholds dialog box, an internal error could occur with identical
    number of emails in different row entries
  - pages labels and message area label could not handle thresholds without
    color
  - in database browsing mode, errors could occur when refreshing viewers with
    cells belonging to unloaded instances
  - in graph viewer, asynchronous module data could be clipped before reaching
    the left side of the graphing area
  - dropping cells of incompatible type in some viewers drop sites could trigger
    a fatal error
- in mounts module, added Solaris support, removed Linux old kernels support
  (before version 2)
- in filesystem dynamic library, on Solaris, also return filesystem block size
  in statistics function
- in snmp and smithy modules:
  - report error when --title option includes table name but no table was
    specified using -t or --table options
  - when --title option includes agent address, display it as specified in the
    -a option, not in dotted form
- in cpustats module, no longer display potentially erroneous values at first
  pass and removed overflow condition
- fixed BWidget image package loading problem if moodss is installed in a
  directory hierarchy including spaces (most likely to happen on Windows)
- reduced standalone binary tarball size by optimizing all compilations for size
- improved Windows related documentation (install.txt)
--- moodss 17.10 and moomps 2.12 -------------------------------- 2003-19-09 ---
- added standalone binary tarball which unpacks in a single sub-directory,
  complete with all required programs and libraries, so that users can very
  easily try moodss
- in standalone binary, include Tcl/Tk 8.4.4, BLT 2.4z, Tktable 2.8 and SQLite
  2.8.6
- added Solaris support:
  - all internal dynamic libraries now also compile on Solaris
  - made Makefile compatible with Solaris make
  - in log module
- in moodss GUI:
  - in stacked bar viewers, it is now possible to fix the Y axis maximum value
    as in graph viewers
  - in pies total value entry, avoid problems with leading zeros in entry
  - in graphs maximum value entry, avoid problems with leading zeros in entry
  - in pies total value entry, a zero value is no longer displayed
  - removed a bug introduced in previous version, which made it impossible to
    stop data cells history archiving in database
  - when reloading a configuration file containing cells the history of which
    was to be archived in database, a fatal error would occur
- successfully tested with mysqltcl MySQL interface library version 2.40
- MySQL modules successfully tested against MySQL server versions 3.23.58 and
  4.0.15
- upgraded myerrorlog module for MySQL 4.0.15 support
--- moodss 17.9 and moomps 2.11 --------------------------------- 2003-09-09 ---
- when recording data cells history to database, handle errors such as
  disconnections when the database server becomes unreachable, by gracefully
  disconnecting and retrying to connect at each update, thus greatly enhancing
  reliability, especially in the moomps daemon case
- gracefully handle all other database potential problems, by either displaying
  or printing error reports, then exiting in case of fatal errors
- in database interface, added debug level option for tracing database queries
  and statements
- made tarball Makefile compatible with Solaris, with specific entries
  (commented out as Linux is the default)
- in moodss GUI:
  - in graph viewers, popup menu could only be used on last viewer to set
    maximum Y axis value, when there were several such viewers displayed
  - in pages labels, pie viewers total entries, graph viewers maximum entries,
    allowed Enter key to validate changes, as the Return key already did
  - in preferences application database section, when connected to database,
    database entry field was not disabled
  - in case of any unexpected database problem, the trace window is displayed
    with the corresponding database error messages
  - in preferences application database section, added SQL trace option for
    debugging database interface
  - in database range dialog box, removed bug which prevented passing from 10 to
    09 in an entry, using the down arrow
  - handle multi-line labels in database module instance tables
  - when changing mode (database browsing, real-time monitoring, ...), no longer
    destroy and re-create menu bar to eliminate annoying flicker
  - avoid unnecessary menu bar, tool bar and drag'n'drop zone updates to reduce
    flickering
- includes latest SQLite 2.8.6 libraries
- Linux modules successfully tested against kernel 2.4.22
- slightly updated INSTALL file
--- moodss 17.8 and moomps 2.10 --------------------------------- 2003-08-25 ---
- in moodss GUI:
  - in preferences, it is now possible to specify a database name other than
    moodss (the default) for the native MySQL driver
  - in pie viewers, it is now possible to fix the total value (corresponding to
    100 % of the pie) from a popup menu which opens an entry zone in the upper
    left corner of the viewer
  - in graph viewers, it is now possible to fix the Y axis maximum value from a
    popup menu which opens an entry zone in the upper left corner of the viewer
  - display red arrow marker in graph viewers when maximum value was manually
    set
  - display total value with red arrow marker in pie viewers when total value
    was manually set
  - in configuration and preferences dialog boxes, application size section,
    added automatic scaling option
  - clicking in a graph viewer outside the graph (black) area would create an
    error (bug introduced in moodss 17.7)
  - when loading a dashboard from the File/Open menu, modules errors created a
    core level error instead of being caught and displayed properly
  - editing pages labels can now be started from mouse button 3 on top on the
    existing double click method
  - in database module instances dialog box, selection and dragging of modules
    and data cells were wrongly enabled instead of just enabling instances
  - in database module instances viewer, forgot to allow dragging directly
    following a mouse button press event
  - an internal error could sometimes occur when clearing display and quickly
    loading from database
- when using a MySQL database via the native MySQL driver (as opposed to ODBC),
  it is now possible to use another database name than moodss
--- moodss 17.7 and moomps 2.9 ---------------------------------- 2003-08-18 ---
- in moodss GUI:
  - significantly improved drag'n'drop functionality by allowing dragging
    directly following a mouse button press event
  - in order to improve history database browsing, allowed dragging time
    value directly from graph type viewers crosshairs into database module
    instances viewer
  - in edit database dialog box:
    - added active column so that a data cell history can be stored or not in
      the database when the user chooses
    - added current value column so it is easy to spot whether a cell still
      contains valid data
    - the current value cell now changes color on thresholds activations,
      instead of previously used label cell
  - when clearing the display (when loading another file, ...), the edit
    database dialog box is now automatically destroyed
  - in preferences dialog box, in application database section, prevent any
    configuration change if currently connected to database
  - in database module instances dialog box:
    - added time range section which displays available start and end times
      for module, instance or data cell selection
    - allow selection of an instance only if it holds data cells history
    - added a widget tip (balloon) holding the module version on all displayed
      module instances
  - when a graph viewer becomes empty, cross hairs are now disabled
  - in preferences and configuration dialog boxes, the wrong tree node could
    remain selected even though the current page data did not check
- in thresholds scripts, added %l importance level substitution
- in thresholds emails, the importance level is now included at the beginning of
  the message (see sample in moodss HTML documentation)
- gracefully handle databases interfaces packages loading errors
--- moodss 17.6 and moomps 2.8 ---------------------------------- 2003-08-04 ---
- added cross threshold capability: scripts or email are activated once only
  when the threshold condition occurs, reset when condition disappears (turned
  off by default for backward compatibility)
- in moodss GUI:
  - in thresholds dialog box, added column for once flag
  - in thresholds dialog box, when testing a threshold, script could be wrongly
    multiply invoked
  - menu, tool bar and drag'n'drop zone were not properly updated when history
    database was opened for browsing, and closed when there were no remaining
    modules instances being displayed
  - when editing cells the history of which is to be archived in database,
    disable starting database recording
  - when cells history is being recorded in database, disallow editing entries
    for cells, the history of which is to be archived in database
  - when there are no loaded modules, disable the Edit Thresholds and Database
    menus
  - in various dialog boxes, such as thresholds, edit database and preferences
    (thresholds email section), use new list of entries implementation, which
    uses a selector with thin black lines and allows cutting and pasting in
    entry fields
  - in File/Modules/Manage dialog box, when trying to reload the sole remaining
    module, if it failed to load due to an initialization error, an internal
    error would occur
  - in File/Modules/Load dialog box, the options values used for the last loaded
    instance of a module are reused when trying to load a new instance for that
    module
  - explained how to reuse options of a module that failed to load in the HTML
    documentation FAQ section
- added support for 4.0.14 MySQL server version in mystatus, myvars and
  myerrorlog modules
- in myerrorlog module, always display the most recent message instance in
  duplicated messages
- included SQLite library in moodss zip package so that database support is also
  available "out of the box" on Windows
- successfully tested with mysqltcl 2.30
- successfully tested with Tcl/Tk 8.4.4
- successfully tested with sqlite 2.8.5, both on Linux and Windows
--- moodss 17.5 and moomps 2.7 ---------------------------------- 2003-07-15 ---
- added SQLite database support, a SQL library that does not require a server
  and therefore is best suited as a single user default database
- included SQLite library in moodss rpm package so that database support is
  available "out of the box"
- when the core (moodss or moomps) is running under Tcl/Tk 8.4 (as opposed to
  8.3), in apache, cpustats, myhealth, mystatus, interrupts, netdev, partitions,
  ps, snmp, smithy modules, the result of integer difference calculations could
  be wrong in the rare cases when source data counters wrapped around
- in moodss GUI:
  - in preferences application database section, added SQLite entry with file
    chooser, check for options compatibility instead of in internal database
    code
  - in thresholds and edit database dialog boxes, implemented better looking
    selector with thin black lines and allowed cutting and pasting in entry
    fields
  - in view poll time dialog box, increase time entry width to 5 digits
  - enlarged edit database dialog box
  - removed small memory leak in edit database dialog box
- in rpm specification file, added SQLite binary library installation
--- moodss 17.4 and moomps 2.6 ---------------------------------- 2003-06-25 ---
- added Oracle database support
- in moodss GUI:
  - use BWidget tree instead of BLT tree implementation
  - use arrow mouse cursor in all help windows
  - no longer exit on database connection failures when starting recording
    history or loading from database
  - help message for empty viewer was stuck when creating bar graphs or pie
    charts by a direct data cell drop into their iconic drop site
- trying to store data cell history from a module without options no longer
  generates an error
- added optional debugging code (commented out) in database layer source code
- in snmp and smithy modules, use full OID in dotted notation for sysUpTime in
  order to avoid MIB lookup
- successfully tested with mysqltcl version 2.20
- added support for 3.23.57 MySQL server version in myvars module
- Linux modules successfully tested against kernel 2.4.21
- requires BWidget latest version 1.6
--- moodss 17.3 ------------------------------------------------- 2003-06-09 ---
- added smithy module, a SNMP module compatible with the existing snmp module,
  but using the MIB Smithy SDK library from Muonics (commercial software), which
  brings compatibility with Tcl/Tk 8.4, SNMPv3, ... (see smithy module
  documentation for more information)
- in snmp module:
  - added support for not accessible index columns in SNMP tables
  - handle non existing column data in SNMP tables by displaying void values
    instead of empty table
  - no longer wrongly consider entries as SNMP tables
  - added --directory option to preset MIBs directory or load all MIBs in a
    directory
  - removed case sensitivity for SNMP version option
  - improved resiliency by detecting incomplete objects when processing bulk
    responses
  - for SNMP version 2, use a single maximum repetition in get bulk requests
    since number of table rows is not known ahead of time
  - detect non regular files in --mibs option
  - fixed time formatting when using Tnm version 3
- in moodss GUI, a void data cell could create an error when an unknown
  threshold was set on that cell
- added comma to valid characters list for a module name
- slightly changed Makefile to make it compatible with Suse rpm build (patch
  submitted by Suse)
- improved rpm specification file using Suse specification file for moodss as a
  model
- added Tcl stubs support for all internal C libraries, both in Makefile and the
  libraries source
--- moodss 17.2 and moomps 2.5 ---------------------------------- 2003-05-25 ---
- in moodss GUI:
  - now compatible with Tcl/Tk 8.4 (used in Suse, Debian, ...)
  - database interface no longer crashes, graph and statistics table viewers now
    work with the buggy Tcl/Tk 8.4/patched BLT combination
  - in preferences dialog box:
    - renamed canvas folder to application
    - added fonts section to application folder to set global application font
      family and size
    - moved trace and database sections under application folder
  - database time range dialog box can now stay open to allow interaction with
    main window
  - database module instances viewer cursors synchronized with database range
    dialog box time inputs
  - in stacked graph viewers, data colors could be altered when enlarging viewer
  - about dialog box contents no longer disappear when display is refreshed
  - added Close button in upper right corner of modules and general help windows
  - about dialog box OK button was replaced by a Close button
  - added help message in empty viewers suggesting to drop cells in them
  - traces and messages issued by modules in their initialization stage are no
    longer lost even if resident trace window is not displayed
  - in database modules instances viewer, X axis stayed hidden
  - in database view range dialog, help button now points to the right section
    in the main help window
  - uses newest BWidget 1.6.0 release
- in moomps daemon:
  - if a module supports the --daemon mode option, it is set so that the module
    can eventually retry on failures in initialization phase (see module
    development section in moodss HTML documentation)
- upgraded myvars and myerrorlog modules for MySQL 4.0.13 support
- in database options table, use TEXT type instead of VARCHAR in value column
  to handle potentially very long options (such as used by snmp module)
- whenever the database history recording process is started, instances and
  entries tables are updated with the latest modules data
- with a MySQL database server, use INSERT DELAYED when storing data cells
  history to improve performance and not adversely affect modules such as snmp
  which may time out when the database server is very busy and INSERT statements
  take too long
- in snmp module, removed case where some uninitialized options could cause an
  error and improved reliability by detecting more error cases in responses
- new instances could be wrongly created in database for modules without options
- includes md5, uri, base64, smtp and mime source from new tcllib 1.4 release
- in Makefile, fixed include variable spelling and no longer use some not widely
  supported install command parameter
- added FAQ section in database HTML documentation
--- moodss 17.1 and moomps 2.4 ---------------------------------- 2003-05-01 ---
- in moodss GUI:
  - added File/Database/Start|Stop menus (and corresponding tool bar buttons)
    for real-time recording of cells history data in database (same
    functionality as the moomps daemon)
  - added View/Database Range menu and corresponding dialog box for precise time
    range specification for database related views
  - in database history mode, try not to change cursors positions when loading
    a new instance or constrain cursors range to a reasonable recent range in
    order to avoid lengthy database queries
  - all viewers can now handle invalid data, such as non numeric data for
    supposedly numeric type cells (in order to be able to handle new snmp
    module)
  - no longer create viewer when dropping data of incompatible type in a viewer
    drop site
  - when dropping data of incompatible type in a viewer or its drop site, warn
    once with a message box
  - when deiconifying a module table, it is now always placed on top of all the
    visible objects
  - when all modules were unloaded, the File/Modules/Load menu was disabled
- included smtp and mime source from tcllib in moodss and moomps so that emails
  on thresholds always function and that tcllib installation is not required
- thresholds test code was made more resilient by being able to handle invalid
  data
- updated MySQL myerrorlog module for 4.0.12 server compatibility
- in snmp module:
  - now always consider any integer or unsigned type syntax as numeric
  - use a less strict syntax to data type conversion
  - slightly improved code efficiency
- in moomps daemon:
  - appended configuration file name to some warning messages
  - even when not in debugging mode, warn if a database connection is defined
    and there are no data cells histories to store, or when there are no active
    thresholds with email recipient or script
--- moodss 17.0 and moomps 2.3 ---------------------------------- 2003-04-13 ---
- in moodss GUI:
  - added complete history database browsing capability, with user interface
    (drag'n'drop, viewers, help, ...) behaving as in real time monitoring
  - added File/Database/Load menu
  - added history database dialog box for modules instances selection
  - added modules instances viewers with start and end cursors for setting
    history database viewing range
  - implemented hidden instance module for holding history database module
    instance data
  - View/Refresh menu and button also refreshes all tables and viewers in
    database mode
  - significantly improved drag'n'drop functionality by prioritizing drop sites
    according to their windows stacking order, and by using a different cursor
    when dragging mouse over a valid drop site
  - in database dialog box, text is now left justified in comments column
  - plugged small memory leak that occurred when destroying displayed data
    tables
  - in print dialog box, made entry fields expand horizontally as window is
    resized
  - fixed bug which prevented the BLT 2.4u graphical library to be used in the
    configuration and preferences dialog boxes
  - in graphs, sometimes thin dark blue lines could appear in data holes
  - when main window was cleared for any reason (unloading all modules, opening
    another configuration file, ...), the message label in the bottom left
    corner disappeared
  - on Windows, enabled database section in preferences dialog box
  - fixed potential problem when opening another configuration file from the
    File menu
  - increased default main window size, tables and viewers sizes as well
  - in moodss, minimize arrows in displayed modules tables would disappear when
    window was shrunk horizontally too much
- in moomps daemon:
  - in database, no longer look at module minor version when deciding to create
    a new instance, as that occurs too frequently when module is upgraded due to
    minor code changes
  - log informational message when any configuration file is reloaded due to a
    change
  - if there were multiples files in a configurations directory, they would not
    be properly checked for updates
  - a database table index is created when the history table is created (see
    HTML documentation, database history table section)
  - in the case of native MySQL connectivity, use DATETIME type instead of
    TIMESTAMP when creating history and instances database tables
  - if a configuration was overwritten by another file with the same name, its
    changes were not taken into account
  - process identifier file, if specified via the command line, is periodically
    touched so that a watchdog external program can decide to restart moomps
    when it is hung (see example in documentation)
  - the process identifier file is touched as often as the configuration files
    are checked
  - added a high availability section in the documentation, with examples
  - rpm package no longer requires moodss, as configuration files can be
    created with moodss from another machine, or, why not, with some custom
    piece of software
  - if cell data history specified but no database defined, log warning
    including corresponding configuration file name, even when not debugging
  - in rpm file, added service configuration in installation scripts so that
    chkconfig command knows moomps
- in configuration files, embedded new lines were not saved in free text viewers
  and thresholds scripts: load those files, correct the relevant texts and
  scripts and save again
- added support for 4.0.12 MySQL server version in myvars module
- removed moodb database browser graphical tool from distribution and moomps
  rpm package since that functionality is now available in moodss from
  File/Database/Load menu
- in generated moodss and moomps binaries, really strip comments only from non
  external source files (feature claimed to be in 16.10 but actually not
  implemented)
- added separate documentation on database (database.htm) to distribution
- uses and includes tclXML and tclDOM 2.6 libraries
- successfully built and tested on Redhat 9
- added releases dates in change log
--- moodss 16.10 ------------------------------------------------ 2003-01-20 ---
- added new disks module for Linux (obsoletes, along with the partitions module,
  the original diskstats module)
- removed diskstats module from distribution
- active page if any is now saved in configuration file and restored
- tabbing in database and thresholds dialog boxes skip disabled cells and should
  now handle table corners properly
- improved cells color management in graph, bar charts and pie viewers, so that
  a cell is guaranteed to be displayed in the same color in all viewers
- slightly changed default viewers colors so that green and cyan are no longer
  adjacent
- in pie viewers, removed potential memory leak on destruction
- in myerrorlog module, added some English and Italian error messages
- in snmp module, prevented some possible divide by zero errors
- in generated moodss and moomps binaries, strip comments only from non external
  source files
--- moodss 16.9 and moomps 2.2.1 -------------------------------- 2003-01-10 ---
- added new partitions module for Linux (requires the "per partition statistics
  in /proc/partitions" feature to be enabled in the kernel (2.4.20 and above))
- modules written in Python now require that tclpython version 3.0 or above be
  installed (featuring the new exec command, available from my homepage)
- in python modules, allow keyboard interrupts (such as generated by Control-C)
  so that the moodss application can be terminated from the keyboard
- in moodss preferences:
  - for target file for printing canvas, and for daemon preferences file, always
    store file names with absolute paths
  - made it possible to create a new moomps daemon preferences file
- documented all error cases in all modules, resulting in rows disappearing or
  data cells becoming void, so that thresholds can be properly applied by user
- in interrupts module, set all counters data cells to void when an error occurs
  in communication with remote host
- in myhealth, myprocs, myquery, mystatus, myvars and odbcquery modules,
  eventually use threads so that core (GUI for example) is not hung on
  connection problems with server (requires Tcl/Tk 8.4.1 with Threads 2.5
  extension, mysqltcl version 2.1 or tclodbc version 2 or above)
- when threads are used, a status line is present at the bottom of the module
  help window while moodss is running
- in myerrorlog module:
  - fixed bug that prevented new log messages to be really displayed as new
  - when monitoring remote host, eventual communication errors are now displayed
    as new messages
  - messages unknown to the myerrorlog module (which should be noted and
    integrated in next releases) are now displayed with a high importance level
    so that they appear on top and can be thus easily detected (please report
    when you see any of those messages of unknown importance level (displayed as
    ?)). Use the --debug-file option described below.
  - added --debug-file option so that a file can be specified for the module to
    automatically store unknown messages (please attach this file to your email
    message to make a complete bug report)
  - improved messages fuzzy matching algorithm performance and precision so that
    messages differing by half their number of words or more are considered
    unknown
  - integrated some previously unknown messages using MySQL server version 4.0.8
- in myhealth module, in case of error, display non numeric void cells as empty
- in partitions module, sizes are now displayed in megabytes instead of blocks,
  which incidentally are now referenced as kilobytes since 1 block is 1024
  in the Linux kernel
- in moodss homepage, improved the download section, complete with the packages
  required by moodss and moomps, optional packages, packages required by
  specific modules, ...
- in moodss HTML documentation, explained threshold settings nuances on void
  data cells of numeric types as opposed to other types
- set a larger size for modules help windows
- in preferences dialog box, for canvas printing, thresholds email, database and
  daemon sections, made fields expand horizontally as window is resized
- no longer display fugitive update messages for internal trace module
- module programmers: in module code, no longer include module name in
  pushMessage and flashMessage invocations, as it now automatically internally
  added at the beginning of the message before being displayed
- added ping module to moodss zip distribution for Windows (requires the Scotty
  extension and a nmicmpd service on remote UNIX host or eventually local
  (untested))
- in ping module, moved replied address column to first table next to the IP
  address column for easier visual comparisons
- in help windows, used a little horizontal padding so that displayed HTML is
  not displayed too close to the left window border
- the Tcl library tcllib is no longer required to be installed for moodss and
  moomps to run
- documented --pid-file and -r options in moomps manual page
- in moomps daemon, modules password option values are no longer stored as
  readable strings (* characters are used as replacement)
- module programmers: in moodss documentation, specified password sensitive
  option names
--- moodss 16.8 and moomps 2.2 ---------------------------------- 2003-01-02 ---
- in moodss preferences interface, added daemon section, where it is possible to
  choose the moomps preferences file
- it is no longer necessary to manually edit the moomps preferences file, since
  it is now generated, in XML, from the moodss preferences dialog box
- in moodss preferences interface, added database section, also used in
  conjunction with the moomps preferences file setting, so that host, user,
  password, ... are saved in moodss preferences file and eventually in moomps
  preferences file if the user has writing rights to it
- all configuration and preferences files now use a standard format, namely XML
  (old format configuration (save) files can still be read but are written in
  XML when saving again, so make a backup of important ones just in case)
- when created on UNIX platforms, all preferences files are readable by only the
  current user, since they can contain passwords
- in graph viewer, made first drawn point always visible, and made vertical
  scale auto adaptive by default
- in configuration and preferences, added the possibility of forcing a minimum
  of zero on the Y axis scale for graph viewers
- in preferences, added trace page with number of rows setting for trace window
- in database dialog box, cells now change color according to threshold
  conditions, as in other viewers
- made diskstats module compatible with new "per partition statistics in
  /proc/partitions" feature in Linux kernels 2.4.20 and above
- updated apache module to make it compatible with most recent server versions
- added support for 4.0.6 MySQL server version in mystatus module
- checked myerrorlog module against 4.0.6 MySQL server
- all MySQL modules were successfully tested with new mysqltcl library version
  2.1
- in moomps daemon and moodb graphical database utility, added -r switch so that
  a preferences (resources) file can be specified on the command line, in place
  of the default /etc/moomps/rc
- in moomps daemon, issue a warning in debug mode when there are no emails and
  no scripts defined in active thresholds
- in moomps daemon, issue a warning if preferences file is not readable
- in moodss, improved startup performance, as preferences were uselessly saved
  every time the application was started
- in generated moodss and moomps binaries, comments are no longer stripped
  since that would remove valid code from included tclXML libraries
- uses and includes tclXML and tclDOM 2.5 libraries
- improved embedded HTML help formatting by removing some unnecessary new lines
- a moomps default preferences file (rc file) is no longer included in the
  distribution and the rpm
--- moodss 16.7 and moomps 2.1 ---------------------------------- 2002-11-11 ---
- provide a makefile for moodss and moomps installation and included binary
  libraries generation on UNIX platforms (see INSTALL file)
- simplified rpm specification file by using included makefile
- in moodss, when deleting the last remaining page, if that was not the first
  created page, remaining tables or viewers would eventually become invisible
  when recreated from save file
- in moomps, attempt to use locks or transactions when creating new module
  instances in SQL history database
- in moomps, no longer abort at first module initialization failure, but instead
  generate an error log message and continue initializing other modules
- in moodss, no longer abort at first module initialization failure, but instead
  display error in a dialog box and continue initializing other modules
- internally simplified HTML help code so that internal directory changes are no
  longer necessary, provided installation is done via the new makefile
- successfully tested on Redhat 8.0 with (rpms on my homepage):
  - Tcl/Tk version 8.4.1
  - tkTable widget library version 2.8
  - tclperl (Perl 5.8 embedded in Tcl) version 2.4
  - tclpython (Python 2.2 embedded in Tcl) version 2.1
  - BLT graphical widgets library version 2.4z
--- version 16.6 ------------------------------------------------ 2002-10-08 ---
- moomps version 2.0: implemented data cells history feature where cell values
  are stored in a database (MySQL or PostgreSQL via ODBC) over time, so that for
  example, common spreadsheet software can be used for presentations, ...
- added Edit/Database menu
- wrote UNIX manual pages for both moodss and moomps
- added support for 3.23.52 and 4.0.4 MySQL server versions in mystatus, myvars
  and myerrorlog modules
- improved internal package management so that modules with a name identical to
  another package (such as log from tcllib) can still be dynamically loaded
- ps module could sometimes initially fail because of an internal divide by zero
  bug
- mounts module now really works from Windows
- uses scwoop widget library version 4.1
- removed myquery modules from windows distribution (use existing odbcquery)
- successfully tested with Tcl/Tk 8.4.0
--- version 16.5 ------------------------------------------------ 2002-08-05 ---
- new log module for monitoring log files on UNIX platforms, such as those 
  updated by the syslogd utility
- in MySQL myvars, mystatus and myerrorlog modules, added support for 4.0.2
  server
- switches for Perl and Python modules did not appear in the modules load dialog
  box
- Perl or Python interpreters were not properly cleaned up when scanned from the
  modules dialog box and a Perl or Python module was in error
- uses the notebook widget from BWidget version 1.4.1
- successfully tested with tcllib 1.3
- successfully tested with Linux kernel 2.4.19
--- version 16.4 ------------------------------------------------ 2002-07-08 ---
- added Windows support to snmp module (read snmp module documentation for
  required software)
- in snmp module:
  - improved end of table detection
  - formatted data of time ticks type as ??d??h??m??s??
  - improved error message when -t(--table) is used on a non table identifier
- dynamically loading a module would reset the poll time increased by the user
- added support for MySQL database server version 3.23.51 to mystatus module
- in a dashboard with several pages, if an inner page was deleted, the saved
  configuration lacked pages indexes, which would prevent the dashboard from
  being properly restored, with viewers eventually becoming invisible
- updated help tool bar icon
- all dialog boxes are now proper transient windows of the main window
- made widget tips (balloons) a little wider so that descriptions in SNMP MIBs
  keep their original formatting
- successfully tested with Tcl/Tk 8.4b1
--- version 16.3 ------------------------------------------------ 2002-06-24 ---
- thresholds messages are now displayed in the trace module window and tables by
  default
- in preferences, added thresholds trace page so that the user can choose
  whether thresholds messages are displayed in the trace module window and
  tables
- in displayed tables and viewers, cell colors depended solely of the last
  occurring thresholds, they now display the most important and latest threshold
  color
- tool bar icons not match menus behavior and are grayed accordingly
- use nicer looking icons from KDE 3 in tool bar
- when loading from a save file, cells with thresholds crossed immediately would
  not be colored on the initial refresh cycle (this problem was only partly
  fixed in 16.2)
- in rpm specification file, removed icon entry which caused problems on some
  other distributions and architectures
- completed HTML documentation better organized in user interface parts
  (although I feel that it should be redone, but I lack the professional skills:
  I am merely a programmer, help would be warmly welcomed)
- in data tables, bottom right cell lower border was not drawn when its color
  was changed due to a threshold condition
- do not allow thresholds as a module name
- thresholds emailing successfully checked against a Lotus server in SMTP
--- version 16.2 ------------------------------------------------ 2002-06-10 ---
- pages tabs now reflect, by their background color, the crossed thresholds of
  highest importance in a page
- pages tabs now feature a widget tip (balloon) containing up to 3 summaries of
  the crossed thresholds in a page
- implemented colors sequencing (frequency: 1 Hertz) in pages tabs when there
  are several crossed thresholds of the same importance but of different colors
  in a page
- messenger header (message label at the bottom left of the application window)
  now also serves as a global active thresholds viewer and implements the new
  pages tab features (crossed thresholds colors and summaries) but for all the
  thresholds in the loaded modules, independently of the presence of pages
- allowed tables or viewers transfer between pages by move into a page tab,
  using the internal window manager handles
- allowed viewer deletion by move into the eraser, using the internal window
  manager handles
- hopefully handled all cases causing an update of pages tabs colors and widget
  tips (unloading modules, deleting viewers, moving viewers and tables between
  pages, updating thresholds, creating first page)
- pages cannot be deleted when running in read-only mode
- in preferences dialog box, validation would fail when there were no pages
  displayed
- deleting a page between others would make all tables and viewers invisible in
  the following pages
- current values table viewers now support non numerical data
- improved anti-vibration code in automatic scroll widgets (please let me know
  if you see scrollbars in viewers, tables, canvas, help, ... hang the user
  interface by constantly appearing and disappearing, as in an infinite loop)
- when loading from a save file, viewers using summary table viewer cells could
  show void values, due to a conceptual hole in the summary table restoration
  code (if you have such dashboards, repair by making sure all viewers show
  valid values, correct if necessary, then save)
- when loading from a save file, cells with thresholds crossed immediately would
  not be colored on the initial refresh cycle
- in thresholds dialog box, update original cell label so that it is correct in
  all cases, such as when loading from a save file
- in global help window, scrolling using the keyboard is immediately enabled
- in moomps daemon, removed debug trace
- use helvetica font again in HTML widget, used in help, as italics are no
  longer displayed with an ugly fixed font on XFree 4.2
- use a common background color for all viewers so that free text viewer color
  is not different from the other viewers on Windows
- successfully tested on Redhat 7.3
- in rpm, shared libraries successfully compiled and tested with gcc 3.1
--- version 16.1 ------------------------------------------------ 2002-05-18 ---
- in Edit menu, added New Page entry, renamed New entry to New Viewer
- allowed page deletion through drag and drop from page tab into eraser, only if
  page is empty or if it is the last remaining page
- when a new page is created, automatically open its tab label for editing, and
  display a short help text in message area
- in preferences dialog box, added canvas pages section where user can choose if
  pages tabs are positioned on the top side or on the bottom side
- viewers circulation using Tab and Shift-Tab keystrokes is now scoped to
  current page
- when editing a page tab label, initially select all characters in entry
--- version 16.0 ------------------------------------------------ 2002-05-12 ---
- added multiple views with notebook pages (at this time only available through
  the --tabs command line option (see HTML documentation and TODO file))
- implemented editing tab labels while running
- implemented automatic saving of tabs in configuration (save) files
- on Windows, in toolbar, do not display print icon when Tkprint package is not
  available
- uses the excellent notebook widget from BWidget version 1.4.0 (many thanks to
  the authors)
- uses tkpiechart version 6.4
- cleaned up main source file to make code easier to read and debug
--- version 15.14 ----------------------------------------------- 2002-05-09 ---
- in thresholds dialog box:
  - added actions column in thresholds table, with an envelope icon when email
    recipients are specified, and a gear icon when a script exists
  - added possibility to drag from current cell value display into thresholds
    table or any viewer
  - thresholds table columns widths are adjusted every time a row is selected,
    deleted or either the Return or Enter key is pressed
- added refresh button in tool bar
- removed eventual flashing on tool bar buttons on UNIX type platforms
- stored main view size (in save files) is now used to set main window size
  instead of canvas area to avoid tool bar presence interference
- when -S(--static) command line option is used, all canvas window manager
  interactions are disabled, such as minimizing and deiconifying
- when main window is resized, existing icons are moved if necessary inside the
  canvas area so they do not become out of reach
- made canvas window manager implementation independent of canvas viewport for
  future multiple views feature support
- in general help window, removed borders around images for better visibility
- updated moodss rpm specification file so that it also works on Suse (not
  completely tested). Please try (and let me know the result):
  # rpm -tb --quiet --clean moodss-15.14.tar.bz2
  Note that the above command generates moodss and moomps rpm files: do not
  use the moomps package as it does not comply to Suse standards yet.
--- version 15.13 ----------------------------------------------- 2002-04-28 ---
- added tool bar with nice icons (borrowed from KDE)
- added View/Tool Bar menu to show or hide the tool bar
- saved tool bar visibility state in moodss preferences save file
- in HTML documentation, updated screen shots, documented module tables
  minimizing feature, new values viewer and tool bar
- File/Save menus are disabled when there are no loaded modules
- menu dynamic help on Windows now works right
- in main window, Control-N binding was wrong
--- version 15.12 ----------------------------------------------- 2002-04-20 ---
- module tables can now be iconified so that they do not clutter dashboards
- added minimize button to module tables
- save module tables minimize state and icon coordinates in configuration (save)
  files
- implemented automatic intelligent icon management in canvas area
- added values table viewer that simply displays current cell values, useful for
  keeping important cells visible, now that module data tables can be iconified
- pie viewers now handle long cell labels better by displaying them in a new
  line
- when resized to a small width, bar chart and graph viewers keep displaying a
  minimally sized graphical area instead of axises remnants
- in myhealth MySQL module, added key efficiency indicator (as in the mytop
  software)
- in ps module, added --files switch for displaying the number of open files per
  process
- slightly improved moodss and moomps daemon startup time
--- version 15.11 ----------------------------------------------- 2002-04-01 ---
- added Control key bindings (B(old), I(talic), O(verstrike), U(nderline) and
  R(eset)) in free text viewer for text formatting
- added widget tip (balloon) help in freetext viewer for formatting help
- moomps daemon and its rpm no longer require scotty software but use internal
  logging library instead (for syslog interface)
- in moomps, SMTP package was not loaded in slave interpreters, so threshold
  email messages could not be generated
- made View menu visible only when there is at least one module loaded
- improved table automatic sizing so that empty trace window looks alright
- dynamic menus help in message area not also work on Windows
- in myerrorlog module:
  - importance level column possible values were reversed to really match the
    standard: emergency: 0, alert: 1, critical: 2, ... (INCOMPATIBILITY if you
    set thresholds on this column cells)
  - signal values in relevant messages were not always scanned properly, which
    could result in such messages appearing with a level more important than it
    should have had
- documented View/Trace menu and functionality
- internal reversing of threshold levels numeric values to really match the
  standard, which should have no effect on the application behavior since
  internal comparison function was also changed so that thresholds with the most
  important levels still appear on top in the thresholds dialog box
- improved INSTALL file and added DEVELOPMENT file which contains information on
  developing new modules and modifying/improving moodss or moomps core
- moomps daemon can now be started in background from moodss installation
  directory
- improved moodss and moomps HTML documentations by displaying source code and
  examples on a light gray background
--- version 15.10 ----------------------------------------------- 2002-03-17 ---
- in MySQL modules, report error when port is specified when connecting via
  local socket (localhost as host)
- added View/Trace menu to display or hide an instance of the trace module in a
  separate window (the trace module allows the visualization of all error and
  informational messages issued by a loaded module)
- when moodss is in read-only mode (-r command line option):
  - do not display File/New and File/Open menus
  - do not check configuration changes when exiting
- in HTML documentation, added Tab and Shift-Tab tables and viewers circulation
  description, and completed modules management dialog box description
- in load module dialog box, module configuration changes were wrongly checked
- in thresholds dialog box, test script outputs are now delimited by separators
  and output is shown only if script is not empty
- on Windows, some background and foreground colors were wrongly chosen, such as
  in modules list selection and emails input lists
- in thresholds dialog box, use a fixed font in script and test output areas, on
  all platforms
- added shared libraries generation instructions in INSTALL file
- trace module now displays module identifiers instead of module indexed
  namespaces in its module column
- simplified trace module implementation
--- version 15.9 ------------------------------------------------ 2002-03-09 ---
- added MySQL myreplication module to monitor a pool of replicated servers
  (master(s) and slave(s) role)
- in File/Modules/Manage dialog box:
  - module parameters can now be changed instead of just displayed
  - added Reload button so that the user can change the parameters of a loaded
    module
  - added New button so that the user can change the parameters of a loaded
    module and using those create a new instance of the module
  - display module name as defined by the module (module identifier) instead of
    module numbered instance
  - eventual changes are checked and reported when selecting another module or
    closing the manage modules dialog box
- implemented tables and viewers circulation using Tab and Shift-Tab keystrokes
- use white background on all editable fields in the user interface
- in MySQL myerrorlog module, when initially displaying the complete log entries
  (--whole option), show all rows with type old so that a threshold placed of
  the top row is not artificially triggered at launch time
- do not propose to save configuration when there has been changes but there are
  no loaded modules
- on UNIX platforms, for HTML help view, use lucida instead of helvetica since
  helvetica italics look ugly sometimes
- if available, use BLT 2.4w slightly nicer looking treeview implementation in
  configuration and preferences dialog boxes
- in module help, no longer display instances since they are available and best
  displayed in File/Modules/Manage dialog box
--- version 15.8 ------------------------------------------------ 2002-02-17 ---
- MySQL myerrorlog module changes:
  - can now monitor UNIX servers from a Windows client (using plink from the
    Windows putty software ensemble)
  - can now monitor Windows servers from Windows and UNIX clients using the new
    --file option
  - displays messages in all supported MySQL languages (Japanese, Russian, ...)
  - displays complete multi-line messages instead of just first line
- in MySQL myvars module, do not display variables related to table types (bdb,
  innodb, myisam) if they are not enabled or supported by the server, in order
  to reduce the displayed table height
- added printing support on Windows (requires the Tkprint extension)
- added thresholds script support on Windows, although limited to commands with
  arguments, not complex scripts as in UNIX
- added File/New menu to unload all modules and delete existing viewers
- in thresholds scripts, use environment shell or commands interpreter when
  available
- overlap bar charts are now dynamically ordered so that all bars remain visible
  with the largest values in the back
- in remote capable modules, no longer hardcode remote shell command (rsh or
  ssh)
  path in case it is not to be found in a standard directory
- on Windows, using the plink command from the great putty software ensemble, it
  is now possible to remotely monitor Linux from Windows with the following
  modules: cpustats, interrupts, kernmods, memstats, mounts, netdev, pci, ps,
  sensors, system
- do not allow screen shots in thresholds when running on Windows
- with the trace module loaded, some update messages could stick at the bottom
  of the main window
- on windows, sorting arrow no longer steps on column title bottom border line
- when updating, the module name as defined by the module code, appears in the
  update message at the bottom of the main window
- added a FAQ section in the moodss HTML documentation: please feel free to
  contribute questions, and even answers ;-)
- added a main features section to the moodss HTML documentation
- added install.txt to windows distribution zip file
- uses tkpiechart extension version 6.3.1
- MySQL modules successfully tested with MySQL 3.23.48
- on UNIX, no longer use bold font for menus, right justified help menu and
  right justified eraser drop zone for consistency with latest graphical
  environments such as KDE and Gnome
- on Windows, for modules specified on command line, when an error occurs when
  initializing a module, a dialog box is displayed instead of sending the error
  message to the standard error channel
- watch (busy) cursor is now systematically used on all modules initializations
  and updates, for better user feedback on slow modules
--- version 15.7 ------------------------------------------------ 2002-02-04 ---
- new MySQL myerrorlog module for monitoring local or remote database servers
  error logs, with more 350 possible messages classified by importance level
- MySQL myhealth module could fail at startup when database server connection
  failed
- MySQL modules successfully tested on Windows ME and 2000 (except myerrorlog
  not yet ready for Windows)
- MySQL modules threaded implementation successfully tested with ODBC but
  disabled for now until mysqltcl implementation can be declared thread safe
- when discovering modules from File/Modules/Load menu, display scanned module
  so that user does not think that the application is hung
- in File/Modules/Load dialog box, display * characters when typing in module
  options that end with "password"
- in File/Modules Load and Manage dialog boxes, made it clear that module
  documentation is available by clicking on Help button after module selection
- minor fixes so that moodss and its MySQL modules work on all windows platforms
- added a zip distribution file for moodss for windows
- in thresholds dialog box, prevent parasitic dragging between table rows
- fixed potential bug when opening a configuration file with a viewer containing
  a cell belonging to a module unloaded prior to saving configuration in file
- when saving in a configuration file, trim all trailing empty lines from free
  text viewers contents
- depending on your Tcl and tcllib installation, smtp package availability used
  for thresholds emails was not always detected properly
- in moomps daemon, removed -q (--quiet) option (moomps is now quiet as opposed
  to verbose by default), added --debug (as in moodss) option
- in moomps daemon, do a better job at detecting bad arguments and problems in
  installation
- in arp module, added some hardware types based on Linux kernel 2.4.17 data
- freetext viewers with data cells originating from different modules were
  sometimes restored from save file with cells in incorrect order
- in trace module, use internationally readable date and time formats
- improved the timing of the update messages at the bottom of the main window so
  that the user can clearly see which module is having a lengthy update
--- version 15.6 ------------------------------------------------ 2002-01-17 ---
- added myhealth module for monitoring MySQL servers important variables and
  indicators (in collaboration with the MySQL developer Sinisa Milivojevic, many
  thanks to him)
- in thresholds dialog box, attempting to create new lines in a script would
  close the dialog box
- unknown thresholds on a non numeric cell would fail when coming from a save
  file
- removed rarely used source versions help menu entry
- added specific moodss and MySQL pages with screenshots on my web site
--- version 15.5 ------------------------------------------------ 2002-01-11 ---
- completely redesigned MySQL myvars and mystatus modules:
  - added support for 4.x servers
  - removed support for 3.22.x servers
  - only display variables returned by the server during the modules
    initialization phase in order to reduce the risk of internal errors due to
    the many different servers configurations in the field
  - dynamic help (through widget tips (balloons)) is now drawn directly from the
    MySQL documentation for greater accuracy
  - displayed variable names are now strictly those returned by the
    corresponding 'SHOW VARIABLES' and 'SHOW STATUS' queries
  - in mystatus module, added separate table for queries counters
  - successfully tested with 3.23.47 and 4.0.1 servers
- in sensors module, forgot to close pipe in local host case
- in sensors module, added support for values with no limits, such as vid
- viewers and thresholds with cells pointing to a non existing module would fail
  (could happen if a module was unloaded prior to saving to a file and then
  opening that same file)
- moomps daemon:
  - added --pid-file option for saving process ID in a file at startup
  - could crash when loading old configuration files with viewers other than
    summary tables
  - added rpm specification file to tarball so that rpms can be rebuilt
    directly
  - in rpm, try to add moomps user even when upgrading, not only installing
  - in rpm, eventually stop moomps daemon when uninstalling or upgrading
  - in rpm, use process ID file for daemon management
- module development: column labels no longer need new lines (except for forced
  formatting) as widget tips (balloons) now wrap lines automatically
- fixed potential bug when loading a module with a new view from an older save
  file
--- version 15.4 ------------------------------------------------ 2002-01-02 ---
- added sensors module for hardware monitoring (requires the lm_sensors package
  to be installed on the system being monitored)
- added Linux interrupts module
- thresholds are now internally ordered according to their importance level so
  that a cell with several active thresholds takes the color of the most
  important threshold (this feature allows importance color gradient effects:
  see threshold notes in HTML documentation)
- in thresholds dialog box:
  - thresholds are displayed with the most important ones on top
  - changing the importance level would result in another row color change
- in file modules dialog boxes:
  - redesign with scrollable modules list on the left of the selected module
    options
  - load module dialog box now has a load button
  - loaded and unload modules dialog boxes replaced by a single manage modules
    interface, with unload button
  - no longer automatically close and allow main window interaction
  - added a close button that replaces the OK button
  - option text entries can now be expanded horizontally
  - help by clicking help button no longer fails for Perl and Python modules
- file modules sub-menu now only contains load and manage entries
- pie, stacked graph and bar viewers did not handle negative cell values
  properly
- in preferences and configuration dialog boxes, enter and return keys failed to
  close the window
- in Python modules, optimized Python to Tcl data conversion assuming dictionary
  keys and some datum values only contain alphanumeric characters, allowed {, }
  and " characters in dictionary values such as HTML text, messages, ...
- in Perl modules, optimized Perl to Tcl data conversion assuming hash keys and
  some hash values only contain alphanumeric characters, allowed {, } and "
  characters in hash values such as HTML text, messages, ...
- in Perl Random module, quoting HTML help data is no longer needed
- in preferences dialog box, thresholds from email address was checked even if
  tcllib smtp package was not available
- in thresholds dialog box, some labels are grayed when there is no threshold
  selection for better user feedback
- saved pies with 2 rows or more of multiline labels are no longer displayed
  with overlapping labels
- fixed potential bug in pie slices scaling handling of invalid values (non
  reproducible, submitted by email)
- moomps:
  - implemented periodic checking of modification of loaded files with
    automatic reload to automatize configuration editing with moodss
  - added -p (--poll-files-time) command line option for periodic checking of
    loaded files
  - implemented -m (--mailto) command line switch so that an email message is
    sent to the specified address at startup time
  - in rpm, add and delete moomps user when installing and erasing
  - in rpm init script, run as moomps user instead of root for obvious safety
    reasons
  - in rc file, added SMTP email outgoing servers, comment lines are now
    allowed
  - duplicate configuration files are processed once only
--- version 15.3 ------------------------------------------------ 2001-12-19 ---
- in moodss, added open file menu entry in order to be able to edit any saved
  configuration files, including those used by moomps
- when saving in a configuration file, trim all trailing blanks from free text
  viewers contents
- in netdev module, a new dynamic interface would cause a failure
- in moomps, only add current directory to Tcl packages automatic loading path
  when -f option is used
- in moomps rpm, previous configuration file is saved if necessary when updating
- in printing to file dialog boxes, open in currently selected file directory
- in open or save file dialog boxes, open in defined file directory or last
  selected file directory
- in moodss, properly report error in a message box when not being able to save
  in a configuration file
- successfully tested with upcoming tcllib release including stooop
- MySQL modules successfully tested with MySQL 3.23.46
--- version 15.2 ------------------------------------------------ 2001-11-15 ---
- moomps first stable release 1.0
- added importance level (emergency, alert, critical, error, warning, notice,
  informational, debug) to thresholds in moodss interface and thresholds email
  messages subject
- moomps now generates proper threshold messages with importance level (defined
  in moodss thresholds interface) into the system log facility
- moomps failed to send email due to output aliasing between interpreters
- moomps failed to use poll time from configuration file
- in thresholds dialog box:
  - added importance level column with floating choice menu initially driving
    the color column
  - deleting a row could misplace some of the following row data
  - deleting a new threshold, then canceling would result in that threshold
    saved
- successfully tested with tcllib 1.1
--- version 15.1 ------------------------------------------------ 2001-11-05 ---
- added odbcquery module for querying any ODBC database (PostgreSQL, MySQL, ...)
  (tclodbc package needed, rpm on my homepage)
- added ODBC support to myprocs, mystatus and myvars MySQL modules, using --dsn
  switch, unixODBC, MyODBC and tclodbc
- in myquery module, added --swap option for swapping rows and columns in
  displayed table
- in moomps, made sure modules output is redirected to log in daemon mode
- removed some unused GUI code from moomps daemon code
- successfully tested with MySQL 3.23.44
--- version 15.0 ------------------------------------------------ 2001-10-31 ---
- added monitoring daemon moomps (Modular Object Oriented Multi-Purpose Service)
  which uses moodss configuration (save) files to send email alerts when
  thresholds occur (see documentation at http://jfontain.free.fr/moomps.htm)
- if a threshold was set on the bottom right cell of a data table, that cell's
  color was not always changed when threshold was crossed
- caught invalid command error when -h option is used
- in help menu, removed copyright entry which displayed the GPL version 2
--- version 14.6 ------------------------------------------------ 2001-10-01 ---
- in threshold alert email message, it is now possible to attach the screenshot
  of the moodss window at the time threshold event occurred
- MySQL modules myvars, myquery, mystatus and myprocs no longer initiate
  connection to test database
- myquery modules wrongly tried to get MySQL processes list
- in preferences, a bug in the thresholds email page prevented properly closing
  the dialog box
- fixed bug in thresholds dialog box that prevented dynamic creation of new
  threshold
- moodss application now uses wish instead of wish8.3 as associated application
  so that for example simply typing moodss works on Redhat 7.1
- in memstats module, added support for Linux kernel 2.4.10
- successfully tested with ghostscript 6.51 (for print preview)
--- version 14.5 ------------------------------------------------ 2001-09-04 ---
- added panes to thresholds dialog box for easier user interaction
- thresholds dialog box table now properly get the input focus
- tabbing to thresholds table invisible cells is now possible
- thresholds dialog box keeps its size when reopened if user previously
   re-dimensioned it
- fixed MySQL myvars module for 3.23.41 servers, by removing ansi_mode and
  adding log_long_queries variable
- all MySQL modules now use mysqltcl library instead of Mytcl library (rpm can
  be found at http://www.xdobry.de/mysqltcl/) because mysqltcl in written in C
  instead of C++, has more functionality, and should give more performance
  thanks to the Tcl object API
- improved Linux diskstats documentation on the 2.4 kernels problem
- some HTML documentation screenshots updated
--- version 14.4 ------------------------------------------------ 2001-08-16 ---
- all data tables now feature thinner separation lines so that more data can be
  visible
- in thresholds and preferences dialog boxes, check syntax of email addresses
  and eventually report errors interactively
- MySQL myvars module updated to support 3.23.41 server
- in thresholds dialog box, clicking several times on a row cell would deselect
  some of the others
- in thresholds dialog box, emails list and script entries states now depend on
  thresholds row selection
- no longer tries to find BLT or tkTable shared libraries in current directory
  when those packages are not properly installed
- requires the newest tkTable widget library version 2.7 (rpm on my homepage)
- successfully tested with Tcl/Tk 8.4a3
- successfully tested with tcllib 1.0
- anecdote: moodss and its modules now total more than 20000 lines of Tcl code
  (actually 132 columns wide lines, which is roughly equivalent to 30000
  "normal" lines)
--- version 14.3 ------------------------------------------------ 2001-06-25 ---
- threshold dialog box functionality greatly improved with data cell current
  value and original label, separate email addresses list, shell script input
  area and test trace area
- in preferences, added the possibility of using multiple outgoing email servers
  for threshold alerts
- improved modules Tcl indexing files (pkgIndex.tcl) so that directories with
  embedded blanks (such as in Windows) do not create problems
- use LOGNAME environment variable for user login when available instead of the
  less common USER
--- version 14.2 ------------------------------------------------ 2001-04-29 ---
- made thresholds table a drop zone for data cells
- MySQL myvars module updated to support 3.23.37 server
- in thresholds table, implemented tabbing between cells
- in save files, data tables column widths are now saved only if module
  specifies resizable columns
- module programmers: added resizableColumns optional boolean in module
  configuration data
- successfully built and tested on a Linux Redhat 7.1 i386 machine
--- version 14.1 ------------------------------------------------ 2001-03-20 ---
- allow multiple concurrent Python modules (tclpython or tclpython2 version
  2.0.1 required)
- implemented dynamic loading of Python modules
- module programmers: module data display was updated even if updates counter
  was not increased, whereas now that condition is actually checked
- cpustats module could fail with a division by zero error on repetitive updates
- MySQL myvars module updated to support 3.23.34 and 3.23.35 servers
--- version 14.0 ------------------------------------------------ 2001-03-02 ---
- modules can now be written in the Python language (the tclpython package is
  required, available in my homepage)
- added Python based randpy and minipy modules
--- version 13.2 ------------------------------------------------ 2001-02-18 ---
- fully documented Perl modules development in HTML documentation
- errors that occurred in the loading phase of a Perl module were not properly
  printed out
- implemented colored relief in selected pie labels
- MySQL mystatus and myvars modules updated to support 3.23.33 server
- Perl module programmers: INCOMPATIBLE (but logical) change: data switches and
  sort members are now hashes instead of arrays (see Random.pm for examples)
- removed the ~!^|;',? characters from the allowed module name set
- removed typo in apachex module code
--- version 13.1 ------------------------------------------------ 2001-02-05 ---
- implemented dynamic loading of Perl modules
- improved performance and reliability of dynamic loading by filtering out well
  known non-moodss packages when scanning for valid moodss modules
- uses and requires tclperl 2.0 to allow multiple concurrent Perl modules
- moodss rpm failed to load modules when used with tcl 8.4 rpm from my homepage
- in netdev module, simplified internal time calculations
- in cpustats module display per CPU statistics only if there is more than 1 CPU
- made graph viewers labels colored rectangles thinner
--- version 13.0 ------------------------------------------------ 2001-01-14 ---
- modules can now be written in the Perl language (the tclperl package is
  required, available in my homepage)
- added Minimal and Random Perl modules (capitalized names)
- module programmers: INCOMPATIBLE change, during a module loading phase, the
  current directory is the module directory, so the packageDirectory array is
  no longer required nor made available to the module 
- MySQL mystatus module updated to support 3.23.31 and 3.23.32 servers
- removed a memory leak that occurred during packages scan when dynamically
  loading a new module
- removed error when no modules are found when trying to dynamically load a new
  module
- a cell with a value of ? was not considered void by the thresholds code
- removed libfilesystem and libnetwork linux binaries from distribution tarball
--- version 12.4 ------------------------------------------------ 2001-01-10 ---
- all viewers now support changing cells colors on threshold conditions
- added view refresh menu for immediately refreshing display of synchronous
  modules
- MySQL myvars module updated to support 3.23.30 server
--- version 12.3 ------------------------------------------------ 2001-01-01 ---
- all displayed cells with threshold now change color depending on related
  threshold configuration (currently only in data tables, not yet in viewers)
- in threshold dialog box, added cell color selection column with colored menu
  buttons, fixed and custom color selection
- selected data cells are displayed with a sunken relief in all viewers (except
  in graph and bar charts where selection is in white, due to a bug in BLT)
- empty threshold values are now allowed except for clock and numeric types
- when cell data is invalid, take no threshold action unless threshold type is
  set to unknown
- threshold condition is now immediately re-checked when threshold value is
  changed
- requires tktable 2.6 (2.5 fails when deleting rows in threshold dialog box)
- new tktable 2.6 rpm and patch on my homepage (recommended but not required),
  with the following fixes:
  - text shifted down in active cell
  - incomplete refresh on expose events
- made check and radio buttons dark gray instead of reddish when selected
--- version 12.2 ------------------------------------------------ 2000-12-23 ---
- thresholds can now be set an all cell data types: ascii, clock, dictionary,
  integer and real
- added differ, equal and unknown threshold types
- in thresholds, the %c cell label replacement in script, email, was incorrect
- in thresholds dialog box:
  - added help widget tips on table titles
  - threshold label was not initialized with monitored cell label
  - multiple line cell labels were improperly handled
- forgot to support clock data type in free text viewer
- MySQL myvars and mystatus updated to support 3.23.29 server
--- version 12.1 ------------------------------------------------ 2000-12-10 ---
- implemented threshold alert by email to one or more addresses (thanks to the
  great mime/smtp package by Marshall Rose, in tcllib, rpm in my homepage)
- threshold deletion is now possible
- in thresholds dialog box:
  - added email addresses column
  - implemented single row selection
  - removed test buttons column, added test and delete buttons that work on
    selected row
  - allow pasting with mouse button 2 on UNIX platforms
  - script column is now left justified instead of centered
  - threshold state was not properly initialized
- in preferences dialog box, added thresholds email folder with from address and
  SMTP server
- in mounts module, ignore filesystems of zero available size, such as proc,
  pts, usb, automount, ...
- in cpustats module, removed a potential memory leak on communication errors
- made data tables automatic column sizing more accurate to avoid small clipping
  by 1 or 2 pixels in some cases
- in MySQL myprocs modules, old processes remained displayed
- updated screenshots in HTML documentation
--- version 12.0 ------------------------------------------------ 2000-12-02 ---
- first pass at thresholds setting capability (see HTML documentation for more
  information)
- added threshold drop icon in main window
- added threshold entry in edit menu
- in MySQL mystatus module, values in kilobytes went negative when value
  retrieved from server (in bytes) passed 2**31
- MySQL mystatus and myvars modules now compatible with 3.23.28 server
- on all displayed data tables, column sizing is now automatic and manual sizing
  is disabled (a module code specific flag will be added in next release to
  enable manual sizing)
- in summary data tables, average column values were wrongly calculated for
  dynamically created rows
- in free text viewer, restoring from save file did not work if data cells were
  inserted in random order
- improved icons look and placement
- set widgets border widths to 1 to improve looks and reduce windows size
- uses scwoop 4.0
- preferences dialog box had configuration in title instead of preferences
- with no module loaded, creating an empty graph viewer would cause an error
- in system module, added number of users and processes rows
- in diskstats module, added support for 2.4 Linux kernel series
- clicking on column title sorting arrow now also toggles sort
- new slicker grayish drag and drop icons
- successfully tested with Tcl/Tk 8.4a2
- uses some new features of Tcl/Tk 8.4 in code whenever possible
--- version 11.23 ----------------------------------------------- 2000-10-29 ---
- data tables visible area is now stored in save file if necessary, which allows
  scrolled tables to be restored in identical state
- MySQL myvars module updated to work with 3.23.27 server version
- MySQL mystatus module wrongly displayed some variables absolute values in
  bytes instead of kilobytes
- all MySQL modules (myprocs, myquery, mystatus and myvars) now default to
  localhost connection instead of 127.0.0.1 in case server skips networking
- in apachex module, added server generation column, filled if available (after
  Apache version 1.3.6, I think)
- apache and apachex modules now report communication error when server is no
  longer reachable, and can recover
- selected cells in data table are now sunken instead of white (color changes
  are reserved for upcoming threshold implementation)
--- version 11.22 ----------------------------------------------- 2000-10-24 ---
- new system module for Linux displaying miscellaneous system information
- new pci module for Linux displaying PCI devices list with information
- all remote capable modules should now work with ssh (successfully tested with
  openssh 2 on a redhat 7 machine)
- made all remote capable modules (arp, cpustats, kernmods, memstats, mounts,
  netdev, ps, route) much more resilient to network errors
- MySQL myprocs module crashed when uptime value for a process was empty (can
  happen when a user is connecting)
- when dynamically loading a module, option values were not properly quoted,
  resulting for example in myquery module consistently failing to load
- added xinetd setup to ping module INSTALL documentation
- use new regular expression features throughout the code
--- version 11.21 ----------------------------------------------- 2000-10-15 ---
- free text viewer now accepts duplicate data cells
- snmp module could crash when system uptime value was missing in cases where
  response contained a no such name error
- updated myvars and mystatus modules with support for MySQL server 3.23.25 only
  in the 3.23 series
- made apachex module fully functional against Apache 1.3.12 servers
- added 2.4 kernel support for memstats module with 7 extra data rows
- multiline messages are now properly aligned in message area
- a small memory leak was removed (could occur when erasing all monitored cells
  from viewers)
--- version 11.20 ----------------------------------------------- 2000-10-07 ---
- successfully developed and tested on redhat 7.0
- /usr/bin/wish8.3 is now directly invoked by moodss
- installing from the rpm puts moodss and its libraries (modules) in the /usr
  hierarchy
- screenshots (with new eraser icon) updated in HTML documentation
- module development: documented large integer values display problem in BUGS
  file
- module development: documented clock module data column type
- more precisely explained configuration / preferences in HTML documentation
- documented why after unloading and reloading a module, a related viewer does
  not resume monitoring the module data
- updated INSTALL file
- updated BUGS file
- if you have redhat 7.0, all you need besides the moodss rpm is the tktable rpm
  from my home page, as blt-2.4u already comes with redhat 7.0

.------------------------------------------------------------------------------.
| versions above and including 11.20 are for Tcl/Tk 8.3.1 and above.           |
| they are now the only actively maintained and improving versions.            |
`------------------------------------------------------------------------------'

--- version 11.12 --- (plus changes between 8.27 and 8.26) ------ 2000-09-26 ---
- tktable 2.5 rpm made available again in homepage
--- version 11.11 --- (see changes between 8.26 and 8.25) ------- 2000-09-11 ---
--- version 11.10 --- (see changes between 8.25 and 8.24) ------- 2000-09-01 ---
--- version 11.9 --- (plus changes between 8.24 and 8.23) ------- 2000-08-14 ---
- uses scwoop package version 3.2
- data tables with non numeric sort columns were not sortable (bug introduced in
  11.7 version)
--- version 11.8 --- (plus changes between 8.23 and 8.22) ------- 2000-08-05 ---
- in ping module, timer between requests for same host was miscalculated,
  resulting in lack of response
- rpm requires tktable 2.6 (available on my homepage)
- successfully tested with Tktable 2.6
--- version 11.7 --- (see changes between 8.22 and 8.21) -------- 2000-07-31 ---
--- version 11.6 --- (plus changes between 8.21 and 8.20) ------- 2000-07-16 ---
- in loaded / load / unload module dialog boxes, selected entry no longer grayed
--- version 11.5 --- (plus changes between 8.20 and 8.19) ------- 2000-06-18 ---
- uses new spinbox widget for poll time entry and configuration dialog box if
  run with wish8.4 from Tcl/Tk 8.4a1
- successfully tested with Tcl/Tk 8.4a1
- stacked graph curves are color filled again
--- version 11.4 --- (see changes between 8.19 and 8.18) -------- 2000-06-05 ---
--- version 11.3 --- (plus changes between 8.18 and 8.17) ------- 2000-05-18 ---
- successfully tested with BLT 2.4s
--- version 11.2 --- (plus changes between 8.17 and 8.16) ------- 2000-04-23 ---
- nouveau fichier LISEZMOI (un grand merci à Eric German pour ses traductions)
- plus de menus et de boîtes de dialogues traduits
--- version 11.1 --- (see changes between 8.16 and 8.15) -------- 2000-04-16 ---
--- version 11.0 --- (plus changes between 8.15 and 8.14) ------- 2000-03-30 ---
- started supporting internationalization (help for languages other than french
  is enthusiastically welcomed)
- french language support in main window menus and context help (available when
  LANG environment variable is set to "fr")
- uses stack from tcllib library
- menus et aide contextuelle en Français quand la variable d'environnement LANG
  est positionnée à "fr"
--- version 10.6 --- (see changes between 8.14 and 8.13) -------- 2000-03-27 ---
--- version 10.5 --- (plus changes between 8.13 and 8.12) ------- 2000-03-20 ---
- successfully tested with BLT 2.4p (official and stubs enabled versions)
--- version 10.4 --- (plus changes between 8.12 and 8.11) ------- 2000-03-17 ---
- Tnm package in snmp module is also searched in /usr/lib hierarchy
- in ping module, use Tcl 8.3.0 new milliseconds clock switch
- in ps module, use Tcl 8.3.0 new milliseconds clock switch
--- version 10.3 --- (see changes between 8.11 and 8.10) -------- 2000-02-28 ---
--- version 10.2 --- (see changes between 8.10 and 8.9) --------- 2000-02-07 ---
--- version 10.1 --- (plus changes between 8.9 and 8.8) --------- 2000-01-04 ---
- use new entry validation facility instead of wcb library
--- version 10.0 --- (plus changes between 8.8 and 8.7) --------- 1999-12-31 ---
- added printing functionality, thanks to Jan Nijtmans (Dash patch) and Jeffrey
  Hobbs (Tcl core integration) great works
- implemented using mandatory Tcl/Tk 8.3b1
- unsuccessfully tested with BLT 2.4n, stick to 2.4m for now
- uses stooop 4.1, scwoop 3.1 and tkpiechart 6.1
- tidied up code now that empty name array bug for static members is fixed

.------------------------------------------------------------------------------.
| versions above and including 10.0 are for Tcl/Tk 8.3 and above               |
`------------------------------------------------------------------------------'

--- version 9.5 --- (see changes between 8.7 and 8.6) ----------- 1999-12-19 ---
--- version 9.4 --- (see changes between 8.6 and 8.5) ----------- 1999-11-24 ---
--- version 9.3 --- (see changes between 8.5 and 8.4) ----------- 1999-11-06 ---
--- version 9.2 --- (see changes between 8.4 and 8.3) ----------- 1999-10-18 ---
--- version 9.1 --- (see changes between 8.3 and 8.2) ----------- 1999-10-03 ---
--- version 9.0 ------------------------------------------------- 1999-09-22 ---
- code updated with empty name array feature for improved performance
- uses stooop 4.0.1, scwoop 3.0 and tkpiechart 6.0
- first version using Tcl/Tk 8.2 features
- as a rpm, installs in /opt/tcltk directory hierarchy
- also includes changes from 8.2 version:

.------------------------------------------------------------------------------.
| versions above and including 9.0 are for Tcl/Tk 8.2 and above                |
`------------------------------------------------------------------------------'
.------------------------------------------------------------------------------.
| versions 8.x are compatible with Tcl/Tk 8.0.x and are no longer supported.   |
`------------------------------------------------------------------------------'

--- version 8.27 ------------------------------------------------ 2000-09-26 ---
- in snmp module, non numeric values are displayed left justified, incomplete
  replies for requests on scalars are processed as much as possible till non
  existing object, and errors such as "no such name" are meaningfully displayed
- ping module was no longer working due to a bug introduced in previous release
- mystatus module now supports only 3.23.24 version of MySQL 3.23 server series
  since created_tmp_disk_tables variable was added
- replaced bullet hole drag and drop site image in main window by a more
  meaningful and less aggressive pencil eraser
- data tables and viewers could not be resized to maximum canvas size when
  canvas was not fully visible
- module development: added new clock data type for module data columns, which
  accepts any format that the Tcl "clock format" command can handle
- trace module date and time columns are now of the new clock type and should be
  always properly sorted
--- version 8.26 ------------------------------------------------ 2000-09-11 ---
- added a trace module, interfaced with the core, with optional filtering, that
  allows messages from any loaded module to be displayed in a table (the trace
  module can be loaded, unloaded, multiply instantiated as any other module)
- existing messages sent from modules to the message area (at the bottom of main
  window) are displayed in trace table(s) if existing
- module development: new traceMessage procedure for modules intended for
  displaying message solely in trace table(s) if it(they) exist(s)
- MySQL myvars module now support 3.23 server versions
- reenabled use of Tktable 2.5 since 2.6 is somewhat buggy in the refreshing
  area
--- version 8.25 ------------------------------------------------ 2000-09-01 ---
- MySQL myselect module now completely generic, renamed to myquery, as it now
  handles any query passed as argument (successfully tested with SELECT and
  SHOW)
- all MySQL modules now allow database server port to be specified (--port
  option)
- all MySQL modules now use the patched Mytcl library (rpm on my homepage)
- all MySQL modules now handle connection errors while running
- when loading from a save file, check save file existence and validity
- help would crash when closing the general help window from the window manager,
  if help was invoked from a dialog box
- in print preview window, zoom menu was no longer usable
- when moving mouse cursor downward into the center of a data table title area,
  then pressing mouse button, table was resized instead of being moved
--- version 8.24 ------------------------------------------------ 2000-08-14 ---
- new MySQL myvars module with full help (using 'SHOW VARIABLE' query, for
  version 3.22 only)
- new MySQL myprocs module (using 'SHOW PROCESSLIST' query)
- new MySQL myselect generic module (using 'SELECT + FROM table' query)
- renamed mysql module to mystatus and display whole set of rows from
  'SHOW STATUS' output for both 3.22 and 3.23 MySQL servers series
- module development: data table or view sort member is now optional, which
  allows displayed data tables column or row sorting to be removed
- apache, memstats and mystatus module tables no longer sortable (was useless)
- added -u (--users) option to ps module to allow display filtering on a list of
  users or their IDs
- in snmp module, displayed data tables use a swapped layout for scalars (when
  -i (--identifiers) option is used alone)
- added Tcl http package configuration options to apache modules: --proxyhost
  and --proxyport
- module development: added miscellaneous package to eliminate some duplicated
  code in a few modules
- added help button to poll time dialog box
- the loaded / load / unload module dialog boxes now prevent interaction with
  main window
- data tables with non numeric sort columns were not sortable (bug introduced in
  8.22 version)
--- version 8.23 ------------------------------------------------ 2000-08-05 ---
- show stopper: a crash would occur when loading from save files including data
  tables with resized columns (introduced in previous release)
- for arp, cpustats, kernmods, memstats, mounts, netdev and route modules, added
  ssh support for remote monitoring (using --remote ssh://user@host option which
  causes /usr/bin/ssh to be invoked instead of rsh (untested, please report
  errors)), improved error detection and avoided read errors (detected on redhat
  6.2) when remotely monitoring
- lots of updates in modules documentation and screenshots
- in netdev module, per second cells show ? instead of 0.0 when value is not yet
  known (before second poll)
- forgot to mention that in 8.22 release, cpustats and memstats modules had
  their table layout swapped
- apache module now uses a single swapped table layout
- arp and cpustats modules table layout were wrongly swapped
- successfully tested with Tktable 2.6
--- version 8.22 ------------------------------------------------ 2000-07-31 ---
- the mysql module now uses a vertical table layout thanks to the new "swap"
  functionality
- in mysql module, added support for 3.23 server with number of kilobytes
  received and sent extra rows
- module development: module data can now be displayed in tables with columns
  and rows swapped (useful when data consists of a single row, for example),
  using the new "swap" boolean keyword in views
- module development: in module code, the views "visibleColumns" keyword has
  been obsoleted (but is still supported) by the new "indices" keyword
- fixed bug that caused a crash when toggling selection on table cells in a
  special sequence
--- version 8.21 ------------------------------------------------ 2000-07-16 ---
- added mysql module (requires tcl-sql package (rpm at http://jfontain.free.fr))
- added help button to all configuration and preferences screens, which launches
  the general help viewer positioned at the related section, in order to keep
  help text in one place and thus facilitate internationalization related work,
  (for 11.x versions and above) even if help takes a while to access the first
  time the help viewer is launched
- added help button to the loaded / load / unload module dialog boxes
- apache modules now properly report connection errors at initialization time
  and display eventual error messages while running
- fixed a small memory leak in loaded / load / unload module dialog boxes
- print dialog box now prevents user interaction with main window
- tables and viewers stacking order can now also be changed with mouse button 2
- added widget tip (balloon) to print, configuration and preferences dialog
  boxes to explain that help may take a while if general help window is not
  opened
--- version 8.20 ------------------------------------------------ 2000-06-18 ---
- added netdev Linux module for network devices statistics
- main window title and menus are properly updated after loading and unloading
  modules
- the moodss application can now be run without any argument since modules can
  be dynamically loaded at any time
- Note to module programmers: the module procedure "terminate" is invoked if it
  exists when the module is dynamically unloaded
- removed long standing bug when in configuration and preferences interface,
  accessing the viewer colors, then another category and finally saving would
  cause an empty set of viewer colors to be saved
- in ps module, forgot to unset a few variables when cleaning up old entries
- available module options were sometimes incomplete after trying to dynamically
  load a previously unloaded module
- the file menu modules sub-menu now contains only what is usable according to
  the current configuration
- trying to print an empty canvas (with no modules loaded) would cause an error
- no longer use different arrow cursor for data table column headers and title
--- version 8.19 ------------------------------------------------ 2000-06-05 ---
- module errors are now caught when dynamically loading a module and proper
  cleanup then occurs with the module being removed from memory
  (Note to module programmers: see "Error handling" in the HTML documentation)
- added --debug command line option for verbose module error reporting
- the apache, apachex, arp, cpustats, diskstats, kernmods, memstats, mounts,
  ping, ps, route, snmp and snmptrap modules now report errors using the Tcl
  error command in order to be completely compatible with dynamic loading
- module help was no longer available when the first instance of the module was
  unloaded
- a dynamically loaded module would find itself twice in an internally
  maintained list, which would cause problems when unloading that module
- module instance numbering has been changed so that holes are filled in the
-   number sequence for a module, instead of a simple incremental scheme
--- version 8.18 ------------------------------------------------ 2000-05-18 ---
- added dynamic module unloading capability (please test although error handling
  when loading and unloading modules is not yet properly finished)
- reimplemented scrolling label used in the message area, so that text flows to
  the left then to the right to accommodate languages read right to left
- moodss no longer crashes in some cases with summary table viewers in a save
  file
- viewer cells labels are now refreshed until they contain no more ? characters
  (note to module programmers: avoid ? characters in module data column labels)
- an error is reported when a module data column label contains a ? character
--- version 8.17 ------------------------------------------------ 2000-04-23 ---
- dynamic module loading is now done through a user friendly interface:
  available modules are automatically discovered and option entries displayed
  for each selected module
- new modules sub-menu in file menu for loading and viewing loaded modules and
  their options
--- version 8.16 ------------------------------------------------ 2000-04-16 ---
- added dynamic modules loading capability: see File / Load Modules new menu
  entry
- modules package version is now automatically generated using RCS facilities
--- version 8.15 ------------------------------------------------ 2000-03-30 ---
- widget tips are no longer clipped when near edge of screen but repositioned
  inside screen
- multiline labels caused confusion in pies labels layout
- in snmp module:
  - columns with counters in displayed tables could not be sorted
  - several requests could be sent before completion of the first request
  - when no SNMP data is returned, all rows disappear
  - when SNMP data becomes available again, old row internal indices are reused
    if possible so that eventual viewers can properly resume displaying data
- in configuration and preferences, graph viewers number of samples was not
  saved
--- version 8.14 ------------------------------------------------ 2000-03-27 ---
- in snmp module:
  - added scalars and groups support using --identifiers option, --table option
    being no longer mandatory as a consequence
  - try to convert object identifiers values to something readable
- in snmptrap module:
  - forgot to decode trap object identifier into trap type
  - print a more helpful error message when connexion to straps daemon fails
--- version 8.13 ------------------------------------------------ 2000-03-20 ---
- added snmptrap module (requires scotty to be installed)
- data cells can now be multiline (can contain one or more \n characters) and be
  properly displayed in data tables
- when any (synchronous or asynchronous) module is updated, a corresponding
  message (one for each module) is displayed at the bottom of the main window
- added --title option to snmp module
- random module now generates multiline data
--- version 8.12 ------------------------------------------------ 2000-03-17 ---
- in HTML documentation, explained that module columns help messages are now
  displayed in widget tips instead of message area
- undefined viewer cell labels (with ?) are now updated once corresponding cell
  data becomes available
- command line module views now appear on top of save file module views
- module internal data indices would get mixed up when specifying command line
  modules on top of those in a save file
- initial module loading and initializing messages are now visible again
- stacked graphs no longer randomly crash when coming from a save file
- graph viewers graduations are no longer randomly invisible
- in snmp module:
  - counters are displayed as per second values for the last polling period
    which is precisely calculated using the agent system uptime
  - counters help (with widget tip) reflects per second nature
  - eventually report SNMP error and corresponding agent address in main window
    message area
  - when table index consists of a single object, it is, if needed,
    automatically placed at the leftmost column position in all views
  - module help was updated
- in memstats module, documented used memory equation
- in ping module, no longer crash when no packets were transmitted, due to
  network being unreachable, for example
--- version 8.11 ------------------------------------------------ 2000-02-28 ---
- added snmp module (requires scotty to be installed)
- a module specific usage message is displayed when the --help switch is part of
  a module arguments
- display print command execution error in a message box
- added help button in print dialog box, directly to corresponding section in
  general help
- in HTML help windows, such as main help, link targets appear at the top of the
  text window instead of centered when hit
- message area at the bottom of the main window now automatically keeps
  scrolling when message is too large for the window
- tables with more than 10 columns clipped title columns
- module columns help messages are now displayed in widget tips instead of
  message area (lower part of main window) in order to handle multi-line texts
- successfully tested with gs (ghostscript) 6.0
--- version 8.10 ------------------------------------------------ 2000-02-07 ---
- print previewing is now done in an application window using gs (ghostscript)
  directly instead of gv (ghostview), on a temporary file
- gs existence and version (5.50 required as 5.10 is buggy) are checked and the
  preview button state set accordingly
- a printer list is automatically made available to the user (/etc/printcap is
  parsed) if the print command line contains the printer generic parameter (%P)
- general and module help windows can now be concurrently opened
- there is now a single help menu entry per module instead of one per menu
  instance, with instance arguments displayed in a list when necessary
- on windows, the correct Tcl library path variable name is now used
--- version 8.9 ------------------------------------------------- 2000-01-04 ---
- in preferences dialog box, added canvas printing folder
- added print preview using gv (ghostview)
- in print dialog box, browse button did not work as it was invoking a namespace
  procedure without namespace specification
- added version, date and time to preferences save file
- in configuration and preferences dialog boxes, use better looking closed and
  opened folder icons
--- version 8.8 ------------------------------------------------- 1999-12-31 ---
- added printing functionality, which should work when required Dash patch is
  installed (many thanks to Jan Nijtmans)
- added printing of canvas area, in postscript, to file or printer, successfully
  tested on UNIX, unlikely to work on Windows for printer output, unless piping
  to a lpr like utility works (please let me know if you succeed)
- detect Dash patch absence and display warning in print dialog box
- in diskstats module, sizes were sometimes wrong due to wrong block size
  estimation, sizes are now in megabytes
- in configuration, an error occurred when closing dialog box when viewers
  colors folder was never accessed
- preferences .moodssrc save file formatted with newlines for easy reading
- included HTML documentation was from the 9.x versions, now is specific
--- version 8.7 ------------------------------------------------- 1999-12-19 ---
- in configuration and preferences dialog boxes:
  - added graphical viewers color sequence setting
  - implemented input error checking when changing pages, applying and closing
  - added data pie labeling type (peripheral or box) selection
--- version 8.6 ------------------------------------------------- 1999-11-24 ---
- added stacked graph viewer
- infinite update loop with automatic scrollbars problem potentially solved:
  when detected, guilty scrollbar is displayed full size (please let me know
  asap about any problems with the scrollbars)
- in ping module, percentage of packets lost was not set when it should have
  been 100%
- tested with BLT version 2.4m
- increased default main window width from 400 to 450 pixels so that all drag
  and drop icons are visible
- in Linux mounts module, ignore automount entry which caused an error
--- version 8.5 ------------------------------------------------- 1999-11-06 ---
- in modules, the ? character is now used for void cells of numeric type
  (integer or real), instead of the 000000 pattern
- apache, apachex and ping modules now use the ? character to indicate void data
  cells
- fixed stupid typo bug in ps module (missing closing curly bracket in ps.tcl
  file)
- in ping module, reply addresses sometimes exhibited stray bytes
- for ping module, unbundled nmicmpd ICMP daemon from distribution, now
  available as a Redhat rpm in my homepage
- uses the wcb library version 2.0 (many thanks to Csaba Nemethi)
- successfully tested with Tcl/Tk version 8.2.2
--- version 8.4 ------------------------------------------------- 1999-10-18 ---
- important bug introduced in 8.0 fixed: data rows would never disappear
  (affected modules: ps, mounts, route, arp, apachex)
- ping module now fully implemented: please test and report problems
- new kernmods module: view of loaded Linux kernel modules
- when there are unsaved configuration changes, the user is warned and given the
  opportunity to save to file before exiting moodss
- cpustats module reported erroneous values after 1st poll
- in ps and mounts modules, when remote monitoring, timeouts were not properly
  handled
--- version 8.3 ------------------------------------------------- 1999-10-03 ---
- added UNIX ping module (uses nmicpmd pinging daemon, binary for Linux
  included, please read INSTALL file in ping sub-directory)
- in network package, added addressfromhost Tcl command
- stooop object oriented library package now included as it is needed by ping
  module
- home page and email moved to free.fr domain
--- version 8.2 ------------------------------------------------- 1999-09-22 ---
- in memstats module, used memory no longer includes buffered and cached memory,
  therefore reflecting reality better (as the KDE kpm top like application does,
  for example)
- diskstats module crashed on multiple CPU systems
- cpustats module now supports systems with several processors
- in save file, canvas scroll area size is used instead of main window size
  since drag'n'drop icons may or may not be present
- version command line switch works again
--- version 8.1 ------------------------------------------------- 1999-08-14 ---
- added configuration dialog box for current view, with data saved along into
  save file. similar to the preferences interface, which is for the application.
  preferences data is overridden by configuration data if save file is loaded
  with -f command line switch.
- forgot to add remote host identification in route module
- module help HTML format was not handled properly (it is now case insensitive
  on the <body> tag)
- all existing modules help is now written in HTML, which allowed inclusion in
  the global help file
- all existing modules help now includes initial data tables images
- in order to better support Debian packaging, HTML documentation has been moved
  to a new documentation sub-directory
- perl is no longer required for building a rpm (Redhat package): sed is used
  instead
- module HTML help handles inline images from the module directory
  (changed to module directory before rendering help data)
- updated CONTENTS file
- HTML documentation updated with one header per menu entry and configuration
  interface description
--- version 8.0 ------------------------------------------------- 1999-07-27 ---
- initial module data tables now feature a title area with the module name, also
  interfaced with the internal window manager for moving and stacking
- in case of duplicate modules, data cells in viewers are labeled as:
    moduleIdentifier: data cell label
  where module identifier is random<2> for example, for the second instance of a
  random module, or a programmer defined identifier
- moodss validModule --badswitch now reports a meaningful error message
- ldelete procedure in ps module interpreter was missing
- errors in modules are now handled gracefully by providing a simple background
  error procedure replacement in module interpreter
- concurrent modules are now completely independent and should not interfere
  with each other, thanks to separate interpreters
- caught error when -help (or shortened version) switch was passed in command
  line on UNIX machines
- changed file menu key bindings to more standard control sequences
- duplicate modules from a save file are now loaded in the correct order
- added optional identifier member in module data so that module is identified
  in initial data tables titles and in viewers data cells: useful when there are
  multiple instances of the same module, or for remote capable modules that can
  now display the remote host name
- applied loose restrictions on characters allowed in module names and
  identifiers
- save files from versions prior to 7.99 can now be read and written
- added remote host identification in module identifier for all remote capable
  modules, as in ps(host.domain.org)
- all remote capable modules now check that remote shell output is empty prior
  to doing anything, in order to avoid confusion on problem origin
- forgot to store summary tables column widths in save file
- added -i(--identify) option to random module for modules identifier testing
- when a summary table referenced an empty cell from another summary table
  (could occur initializing from a save file with a ps module instance and
  vanished processes), a Tcl error would occur due to a ? character in a
  mathematical expression. Now empty cells in summary tables are displayed as
  000000 instead.
- added "void values as numbers" trick in HTML documentation
- changed the internal messenger API (see the "Displaying messages" section in
  the HTML documentation)
- added checkRemoteOutputEmptiness procedure to network package and increased
  its package version to 1.3
- in ps module, TTY names are now correct, clearly displayed and support pts
  devices (useful with 2.2 kernels)
- new homepage mirror at http://jfontain.free.fr/
--- version 7.99 ------------------------------------------------ 1999-07-16 ---
- load each module in its own Tcl interpreter
- which allows several instances of a module on the command line
--- version 7.1 ------------------------------------------------- 1999-06-28 ---
- added colors interface to canvas in preferences dialog box
- split canvas configuration into size and colors interfaces 
- built and tested on Redhat 6.0 (with kde)
- rpm generated on Redhat 6.0 with rpm 3.0
- tested with Tktable 2.5 and BLT 2.4i (which no longer crashes on some graphs
  manipulations as 2.4h did)
- also tested with Tcl/Tk 8.1.1
- latest BLT and Tktable libraries binaries available in my homepage for both
  8.0.5 and 8.1.1 versions of Tcl/Tk
--- version 7.0 ------------------------------------------------- 1999-05-10 ---
- first implementation of a preferences dialog box using a tree widget (thanks
  to BLT)
- added integer input filtering and input length limiting in preferences and
  poll time dialog boxes, thanks to the wcb package
- added Edit menu hierarchy in menu bar with Preferences menu choice
- New menu hierarchy is now a child of the Edit menu
- Options menu renamed to View
- added credits for BLT, Tktable and wcb in About dialog box
- fixed bug which prevented moodss to run on windows due to the missing
  application icon image
- tested with Tcl/Tk 8.1 (BLT and Tktable precompiled libraries for Linux can
  be found on my homepage) (also see BUGS file for BLT)
--- version 6.7 ------------------------------------------------- 1999-04-27 ---
- added context help (through main window message area) on all menus
- apachex module is now compatible with apache versions (1.3.6) which return
  child generation number in extended status data
--- version 6.6 ------------------------------------------------- 1999-04-21 ---
- added automatic crosshairs with coordinates in message area for graphs
- in pie charts, selection uses all viewers color scheme instead of widening
  labels rectangle borders (selected label goes white)
- uses tkpiechart version 5.3
--- version 6.5 ------------------------------------------------- 1999-03-24 ---
- documented information display in main window message area from within a
  module
- reorganized global variables in specific namespace
- removed all unofficial BLT code now that 2.4h is also available on Windows
  (successfully tested)
- tested with BLT 2.4h, but graphs may cause crashes: see BUGS file
--- version 6.4 ------------------------------------------------- 1999-03-01 ---
- module(s) loading and initialization are now reported to the user in the GUI
  message area before main window is completely built
- reorganized and cleaned up code in moodss.tcl
- in apachex module, added column with dynamic traffic for slot
- in apachex module, request age is decoded in d(ays), h(ours), m(inutes) and
  s(econds) instead of just displayed in seconds
- all remote capable modules no longer block user interface and other modules
  when initializing and updating
--- version 6.3 ------------------------------------------------- 1999-02-01 ---
- added apachex module (extended statistics for Apache WWW server)
- fixed a crash that occurred when mutating a viewer with one or more vanished
  cells (belonging to a deleted summary table, for example)
- flash a warning message when some cells no longer exist and disappear during a
  viewer mutation
- fixed an internal window manager bug that sometimes occurred when mutating
  a viewer
- selection order is now preserved when extending cell selection
- in some cases, extending cell selection (shift-click) in a viewer with no
  selected cells would select more than 1 cell
--- version 6.2 ------------------------------------------------- 1999-01-25 ---
- added apache module
- added global array holding module directories (useful for accessing files
  local to the module sub-directory)
- added images embedding capability in modules HTML help file (see random module
  example)
- in Linux cpustats module, removed empty "percent" column (see single view
  trick in HTML documentation)
--- version 6.1 ------------------------------------------------- 1999-01-17 ---
- module help can now be a HTML document (see random module example with
  separate HTML file in module sub-directory)
- use a Help Modules sub-menu per module
- support -geometry command line option
- HTML formatted help documentation for Linux arp module
--- version 6.0 ------------------------------------------------- 1999-01-13 ---
- added module command line arguments support, as in following example:
  $ moodss ps --remote user@host route -r user@host --numeric
- from Help, Modules menu, show invocation arguments per module in help window
- added optional switches data member and initialize procedure support in module
  code
- added table data column anchoring (center, left or right) support in module
  code
- implemented remote monitoring for ps and mounts Linux modules
- added full command line table column to Linux ps module, now split in 2 table
  views
- added -r (--remote) argument option to all Linux modules that support remote
  monitoring (MOODSSREMOTE environment variable technique obsoleted)
- added -n (--numeric) argument option to arp and route Linux modules, to
  prevent host and network symbolic name lookup
- added --show-modules command line switch for discovering valid moodss modules,
  using Tcl package auto loading mechanism
- added minimal module for helping module programmers
- added -a (--asynchronous) argument option to random module
- in Linux modules supporting remote monitoring, close standard input for rsh so
  that moodss can be run in background
- for diskstats and mounts Linux modules, fixed version parsing bug which caused
  an error with 2.2.0pre kernels
- moodss Redhat rpm no longer includes the tktable library but rather requires
  the tktable rpm (see http://rufus.w3.org/ or INSTALL file for exact location).
- some code cleanup and modularization
--- version 5.8 ------------------------------------------------- 1998-12-26 ---
- added experimental remote monitoring for some Linux modules (cpustats,
  memstats, route and arp) using rsh, as in:
    $ MOODSSREMOTE=user@host moodss.tcl memstats
--- version 5.7 ------------------------------------------------- 1998-12-24 ---
- added arp module for Linux with hardware address automatic decoding (full name
  from the /etc/ethers file, or vendor code from included vendor.txt map file)
- fixed a bug in Linux ps module which would crash when seeing processes
  belonging to users added after the application was launched
- made the Linux ps module resilient to vanished process situations
- moodss Redhat rpm no longer includes BLT library but rather requires the blt
  2.4 rpm, part of the Redhat distribution
--- version 5.6 ------------------------------------------------- 1998-12-22 ---
- added route module for Linux
- prevented disk size overflow in diskstats Linux module
- clearly specified that row numbers must be between 0 and 2147483647 (in
  random.tcl comments)
- dragging from a pie by clicking on the background slice no longer fails
- uses tkpiechart version 5.2.2
--- version 5.5 ------------------------------------------------- 1998-12-13 ---
- added Linux mounts module
- fixed a bug introduced in 5.4 which caused module tables geometry not to be
  initialized from save file
- removed libstatfs.so loadable library from Linux diskstats module
  sub-directory
- added packlibs package sub-directory with namespaced filesystem loadable
  library for Linux
--- version 5.4 ------------------------------------------------- 1998-12-10 ---
- added Linux diskstats module with statfs library
- modules specified on the command line can now cohabit with the -f (--file)
  command line option so that new module data displays can be added to an
  existing dashboard
- graph viewers created through New menu had an incorrect time scale
- module errors are no longer caught at load time for easier debugging
- tested with tkTable 2.4 on Linux
--- version 5.3 ------------------------------------------------- 1998-11-29 ---
- viewer icons can now be dropped into existing viewers to change their type
  (for example, create a stacked data bar viewer from several cells, then drag
  the 3D pie drag'n'drop icon into it and see what happens)
- trash icon can now be dropped into any existing viewer to destroy it in 1 shot
- added New menu in order to be able to create empty viewers of any type
- prevented tables rightmost column resizing through rightmost border
- deleting all elements in a viewer no longer causes an automatic destruction of
  the viewer itself (the free text viewer always has behaved that way)
--- version 5.2 ------------------------------------------------- 1998-11-24 ---
- viewers stacking order is now restored from save file
- HTML help no longer crashes application when prematurely closed from window
  manager
- updated INSTALL file with BLT library latest version
- produces an appicon when used with the WindowMaker window manager
- iconifies with nice icon and meaningful label
- replaced all mygale.org domain based personal email and web addresses with new
  multimania.com domain
- tested with Tcl/Tk 8.0.4 on Linux
- uses BLT 2.4g and not 2.4h as reported in version 5.1 changes
--- version 5.1 ------------------------------------------------- 1998-11-15 ---
- viewers with data cells originating from summary tables can now be
  successfully rebuilt from save file (may incur some save file
  incompatibilities with previous moodss versions)
- save file now stores all displayed tables column widths (useful after user
  resizing, for example)
- HTML help now includes images either found in the local directory or the
  /usr/doc/moodss-5.1/ directory if moodss was installed as a rpm
- viewers created from save file were not completely deleted when dropped in
  trash
- fixed graphs initial flat line problem and made it invisible again
- removed some memory leaks that occurred when deleting some viewers
- all new viewers (except for free text) are now created with the same size
- removed programmer specific help from moodss global help window
- prevent data cell(s) drag and drop from within same summary table
- graph viewers created from save file had their time scale improperly
  initialized
- deleted summary table viewer now makes sure that viewers watching its data can
  eventually show that cell(s) data has become invalid
- found a way around core dumps (when exiting moodss, on Linux and probably
  other UNIXs) caused by use of graph viewers
- uses stooop 3.7, scwoop 2.6, tkpiechart 5.2.1 and BLT 2.4h
--- version 5.0 ------------------------------------------------- 1998-10-22 ---
- added free text viewer, based on text widget, with embedded live data cells
- uses scwoop library version 2.5
- fixed various syntax problems thanks to Larry Virden's check with tclpro
- tables are now created with a fixed size due to new scroll class
  implementation
- tested with BLT library version 2.4f
- added source files versions display with corresponding entry in help menu
- reduced height of contents area in global HTML help
- main canvas and table viewers can no longer take focus
- added viewer specific options field in .moo save files
--- version 4.4 ------------------------------------------------- 1998-09-16 ---
- added Redhat rpm support: modules and packages are also searched in
  /usr/lib/moodss
- moodss rpm file, complete with BLT and Tktable compiled libraries made
  available
--- version 4.3.1 ----------------------------------------------- 1998-09-06 ---
- fixed save file fatal error introduced in 4.3
- uses stooop 3.61
--- version 4.3 ------------------------------------------------- 1998-09-04 ---
- added support for asynchronous modules (with data updated without polling)
- successfully tested with Tcl/Tk 8.0.3 on Linux
--- version 4.2.1 ----------------------------------------------- 1998-08-25 ---
- tested with tkTable 2.3 and BLT 2.4e on Linux
- BLT 2.4e required on UNIX platforms
- on UNIX, use libBLT.so.2.4 instead of libBLT2.4.so naming
- Linux BLT and tkTable binaries posted on my homepage
--- version 4.2 ------------------------------------------------- 1998-07-29 ---
- summary table can now handle vanishing cells
- tested with tkTable 2.3 and BLT 2.4c on Linux
- tested with tkTable 2.3 and BLT 8.0 unoff on windows
- drag highlighting frame placement problem fixed on windows
--- version 4.1 ------------------------------------------------- 1998-07-19 ---
- added summary table (current, average, minimum and maximum values) viewer
- unofficial BLT 8.0 version no longer supported on UNIX platforms: use BLT 2.4
  instead
- added -r (--read-only) option
- added -S (--static) option
- moodss self contained application no longer tries to load stooop, scwoop or
  tkpiechart packages if present on the system
- added separate viewer image samples in HTML documentation
- tested with tkTable 2.2 and BLT 2.4c
--- version 4.0 ------------------------------------------------- 1998-06-20 ---
- implemented storing and retrieving current modules and viewers configuration
- added Save and Save As... File menus
- added -f (--file) command line option
--- version 3.6 ------------------------------------------------- 1998-06-14 ---
- pie charts now resize nicely (slices always leave room for labels as BLT
  charts do)
- uses stooop 3.6 and tkpiechart 5.2
- drag circle cursor is no longer changed to double arrow when dragging across
  right side of a table
- column resizing cursor no longer sticks in column title labels
- dragging now possible only from selected cell or viewer element label
- in graphs, flat 0 lines are now visible even with other lines in the graph
- graphs now handle void value with plot discontinuities
- graph background is now black for better clarity
- graph start plotting only when fed new values (no more initial flat lines)
--- version 3.5 ------------------------------------------------- 1998-05-24 ---
- added optional multiple views per module
- added visibleColumns and views members in module data array
- columns member in module data array is now obsolete
- in modules help, display version for each module
- use GNU copyleft license
- removed -update command line option
- implemented GNU style command line options
- added -h (--help), -p (--poll-time) and --version command line options
--- version 3.4 ------------------------------------------------- 1998-05-16 ---
- piecharts are now resizable
- new graph viewer x axis division algorithm taking actual plot width into
  account (axis also updated as viewer is resized)
- graph viewers labels now show data values as barcharts do
- use official BLT version 2.4 instead of patched 2.3 (see INSTALL file)
--- version 3.3 ------------------------------------------------- 1998-05-01 ---
- also announced in comp.os.linux.announce newsgroup
- added memstats module for Linux
- when resizing and moving viewers, show sizes and coordinates in message area
- added support for BLT 2.3 patched for Tcl/Tk 8.1 (see INSTALL file)
- added overlap barchart viewer when BLT 2.3 is used
- infinite update loop with automatic scrollbars problem was not actually
  solved: new implementation with scrollbars appearing and disappearing at once
- use narrower scrollbars with thin border on data tables
- immediately update newly created viewers with current data values
- new graph viewer x axis range was not calculated according to current poll
  time
- implemented graph viewer x axis division varying with poll time
- show only hours and minutes on graph viewer x axis
- updated INSTALL file with BLT and tkTable libraries latest locations
--- version 3.2 ------------------------------------------------- 1998-04-28 ---
- use a little arrow indicator in sorted column title instead of highlighting
- tkTable widget version 2.0 mandatory
- allowed interactive column resizing in tables
- prevented infinite update loop (automatic scrollbars appearing and
  disappearing) which randomly occurred when resizing tables or columns
- use arrow cursor as default in tables, graphs and barcharts
- when clicking on borders, internal window manager places window on top if
  partly visible
--- version 3.1 ------------------------------------------------- 1998-04-25 ---
- the first software to use the fantastic tkTable widget version 2.0!
- added multiple cell selection support to data tables
- implemented tables shifting in initial placement when multiple modules
- use smaller helvetica font for embedded HTML help viewer
- made internal window manager mid handles larger
- added section numbering to HTML documentation for easier reading
- prevented module repetitions in command line
- uses tkpiechart 4.3
--- version 3.0 ------------------------------------------------- 1998-04-21 ---
- added multiple module concurrent support
- implemented multiple modules help
- full support of shift/control click selection method for data cell viewer
  elements
- in cpustats module, added static percent index column for meaningful viewer
  labeling
- uses scwoop 2.2, tkpiechart 4.2 and stooop 3.5.1 packages
--- version 2.3 ------------------------------------------------- 1998-04-19 ---
- added multiple data element drag and drop between graphical viewers
- added multiple data element drag and drop from viewers to iconic drop sites
- in module data array, added list of columns member to specify row index
- any mouse click makes widget tip disappear again
- dropping into initial drag site is now impossible
- drag and drop highlighting now works properly on Windows
--- version 2.2 ------------------------------------------------- 1998-04-06 ---
- pie chart slices can now be selected and dropped into trash
- added general help by using the great HTML library by Stephen Uhler from Sun
  Microsystems (thanks Stephen, great work!)
- added related copyright notice in about dialog window
- slight improvement on pie icons
- used tkpiechart 4.0 and stooop 3.4 switched package
- prevented drag from data table title row
- added support for Windows tktable.dll and blt80.dll for using without tkTable
  and BLT installed as packages
--- version 2.1 ------------------------------------------------- 1998-03-12 ---
- added side and stacked bar charts, 2D and 3D pie charts
- added trash drop site for deleting graph lines, bars and pies
- derive graphData from viewer and blt2DViewer
- better looking icons
- tested with Windows 95 (see the INSTALL file)
- use BSD type copyright (much simpler than GNU copyleft)
--- version 2.0 ------------------------------------------------- 1998-01-18 ---
- data viewers movable and resizable through internal window manager
- added BLT graph data viewers
- added drag'n'drop
--- version 1.0 ------------------------------------------------- 1997-09-22 ---
- table only with no graphical viewers
